<?php

function check_php_version ($a = '0', $b = '0', $c = '0')
{
    global $PRG_PHP_VERSION;
 
    if(!isset($PRG_PHP_VERSION))
        $PRG_PHP_VERSION = substr( str_pad( preg_replace('/\D/','', PHP_VERSION), 3, '0'), 0, 3);

    return $PRG_PHP_VERSION >= ($a.$b.$c);
}


if ( !check_php_version(4,1) ) {
  global $_COOKIE, $_ENV, $_FILES, $_GET, $_POST, $_SERVER, $_SESSION;
  global $HTTP_COOKIE_VARS, $HTTP_ENV_VARS, $HTTP_POST_FILES, $HTTP_GET_VARS,
         $HTTP_POST_VARS, $HTTP_SERVER_VARS, $HTTP_SESSION_VARS, $PHP_SELF;
  $_COOKIE  =& $HTTP_COOKIE_VARS;
  $_ENV     =& $HTTP_ENV_VARS;
  $_FILES   =& $HTTP_POST_FILES;
  $_GET     =& $HTTP_GET_VARS;
  $_POST    =& $HTTP_POST_VARS;
  $_SERVER  =& $HTTP_SERVER_VARS;
  $_SESSION =& $HTTP_SESSION_VARS;
  if (!isset($PHP_SELF) || empty($PHP_SELF)) {
     $PHP_SELF =  $HTTP_SERVER_VARS['PHP_SELF'];
  }
}


/* if running with magic_quotes_gpc then strip the slashes
   from POST and GET global arrays */

if (get_magic_quotes_gpc()) {
    prgstripslashes($_GET);
    prgstripslashes($_POST);
}


/* strip any tags added to the url from PHP_SELF.
   This fixes hand crafted url XXS expoits for any
   page that uses PHP_SELF as the FORM action */

$_SERVER['PHP_SELF'] = strip_tags($_SERVER['PHP_SELF']);



/* recursively strip slashes from the values of an array */
function prgstripslashes(&$array) {
    if(count($array) > 0) {
        foreach ($array as $index=>$value) {
            if (is_array($array[$index])) {
                prgstripslashes($array[$index]);
            }
            else {
                $array[$index] = stripslashes($value);
            }
        }
    }
}



define('PRG_INORDER',0);
define('PRG_GET',1);
define('PRG_POST',2);
define('PRG_SESSION',4);
define('PRG_COOKIE',8);
define('PRG_SERVER',16);
define('PRG_FORM',32);

/**
 * Search for the var $name in $_SESSION, $_POST, $_GET,
 * $_COOKIE, or $_SERVER and set it in provided var. 
 *
 * If $search is not provided,  or == PRG_INORDER, it will search
 * $_SESSION, then $_POST, then $_GET. Otherwise,
 * use one of the defined constants to look for 
 * a var in one place specifically.
 *
 */


function getAllVars($search= PRG_INORDER) {
  if ( !check_php_version(4,1) ) {
    global	$HTTP_COOKIE_VARS, $HTTP_GET_VARS, $HTTP_POST_VARS, 
    		$HTTP_SERVER_VARS, $HTTP_SESSION_VARS;

        $_COOKIE  =& $HTTP_COOKIE_VARS;
        $_GET     =& $HTTP_GET_VARS;
        $_POST    =& $HTTP_POST_VARS;
        $_SERVER  =& $HTTP_SERVER_VARS;
        $_SESSION =& $HTTP_SESSION_VARS;
    }
    $ret=array();
    switch ($search) {
      default:
      case PRG_INORDER: $ret=array_merge($_GET,$_POST,$_SESSION); break;
      case PRG_POST:	$ret=$_POST; break;
      case PRG_GET:	$ret=$_GET; break;
      case PRG_COOKIE:	$ret=$_COOKIE; break;
      case PRG_SESSION:	$ret=$_SESSION; break;
      case PRG_FORM:	$ret=array_merge($_GET,$_POST);break;
      case PRG_SERVER:	$ret=$_SERVER; break;
    }
    return $ret; 
}
 
function getGlobalVar($name, &$value, $search = PRG_INORDER) {

    if ( !check_php_version(4,1) ) {
        global $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $HTTP_POST_VARS, 
               $HTTP_SERVER_VARS, $HTTP_SESSION_VARS;

        $_COOKIE  =& $HTTP_COOKIE_VARS;
        $_GET     =& $HTTP_GET_VARS;
        $_POST    =& $HTTP_POST_VARS;
        $_SERVER  =& $HTTP_SERVER_VARS;
        $_SESSION =& $HTTP_SESSION_VARS;
    }
    switch ($search) {
      default:
      case PRG_INORDER:   // check session, post, get
      case PRG_SESSION:
        if (isset($_SESSION[$name])) {
            $value=$_SESSION[$name];
            return TRUE;
        }
	elseif ( $search == PRG_SESSION )
            break;
      case PRG_FORM:
      case PRG_POST:
        if (isset($_POST[$name])) {
            $value = $_POST[$name];
            return TRUE;
        }
	elseif ($search == PRG_POST)
          break;
      case PRG_GET:
        if (isset($_GET[$name])) {
            $value = $_GET[$name];
            return TRUE;
        } 
        break;
      case PRG_COOKIE:
        if (isset($_COOKIE[$name])) {
            $value = $_COOKIE[$name];
            return TRUE; 
        }
        break;
      case PRG_SERVER:
        if (isset($_SERVER[$name])) {
            $value = $_SERVER[$name];
            return TRUE;
        }
        break;
    }
    return FALSE;
}





function args($ar="",$ignore="") {
  $return="";
  if ( !check_php_version(4,1) ) {
    global $HTTP_GET_VARS, $HTTP_POST_VARS;

    $_GET     =& $HTTP_GET_VARS;
    $_POST    =& $HTTP_POST_VARS;
  }
  
  $arr=array_merge($_GET,$_POST);
  if ($ar) {
    if (!is_array($ar)) {
      list($key,$val)=split("=",$ar);
      $ar=array();
      $ar[$key]=$val;
    }
    else {
      reset($ar);
      while (list($key,$val)=each($ar)) {
	if (isset($arr[$key]))
	  unset($arr[$key]);
      }
    }
    $arr=array_merge($arr,$ar);
  }  

  reset($arr);
  while (list($key,$value) = each($arr)) {
    if ($key && $value)
      if ($ignore) {
	if (is_array($ignore)) {
	  $find=0;
	  reset($ignore);
	  foreach ($ignore as $ign)
	    if ($ign == $key)
	      $find=1;
	  if (!$find)
            $return.=$key."=".$value."&";
	}
	elseif ($key!=$ignore)
          $return.=$key."=".$value."&";
      }
      else
        $return.=$key."=".$value."&";
  }
  return $return;
}

?>