<?php

/* constats for formatting output */
define('RESULT_HTML',0);
define('RESULT_GRAPH',1);
define('RESULT_PLAIN',2);


function list_table($table,$where="") {
  $list_t=array();
  $v=SQL_escape($table);
  $res=SQL_query("SELECT $v.id,$v.name FROM $v $where");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $list_t[$row[0]]=$row[1];
    SQL_free_result($res);
  }
  return $list_t;
}


function GetTableFields($name) {
  $return="";
  $res=SQL_query("DESC ".SQL_escape($name));
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      if ($return)
        $return.=",".$row[0];
      else
        $return=$row[0];
    }
    SQL_free_result($res);
  }
  return $return;
}


function formatlinkstring($str) {
  global $ws;
  $line=$str;
  $line=eregi_replace("AS *([[:digit:]]+)",ShowLink("AS\\1",PRG_PATH."src/data/info_as.php?command=1&ws=$ws&as=\\1"),$line);
  $line=eregi_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]",ShowLink("\\0","\\0",'','TARGET="info"'),$line);
  $line=eregi_replace("[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}",ShowLink("\\0","mailto:\\0",'','TARGET="info"'),$line);
  return $line;
}


function stat_getdetail($id,$name="",$ext="") {
  $ret=array();
  $where="WHERE id like '$id'";
  if ($name)
    $where.=" and name like '$name'";
  if ($ext)
    $where.=$ext;

  SQL_query("DELETE FROM x_stat WHERE access<from_unixtime(unix_timestamp()-7776000)"); /* 90 day */
  
  $res=SQL_query("SELECT id,name,value,access FROM x_stat $where ORDER BY name");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      $ret[]=$row;
    SQL_free_result($res);
  }
  return $ret;
}



function xformat_time($type,$time) {
  global $timeformat;
  return strftime($timeformat,$time);
}



function xformat_ip($type,$ip) {
  global $drn;
    
  if (!is_ip($ip))
    $ip=num2ip($ip);
    
  if ($drn)
    return $ip;

  $domain_name=gethostbyaddr_cache($ip,25);

  if ($type==RESULT_PLAIN)
    return $domain_name;

  if ($domain_name==$ip)
    $domain_name="";

  if ($type==RESULT_GRAPH)
    return $ip."\n".$domain_name;

  return $ip."<br/>".$domain_name;
}


function xformat_bytes_pck($type,$val,$perc="") {
  global $dsd;
  
  if ($perc)
    $perc=" (".round($perc,2)."%)";
  else
    $perc="";
    
  if (!$val)
    $val="0";
    
#for table ...    
  if ($type==RESULT_HTML) {
    if ($dsd) {
      if ($val>=1000)
        return $val."<BR>".number2human($val).$perc;
      else
        return $val."<BR>&nbsp;".$perc;
    }
    else
      return number2human($val).$perc;    
  }
  return $val;
}

function xformat_app($type,$val,$url="",$other="") {
  global $cache_app_list,$drn;
  
  if ($drn)
    return $val;
    
  if ($val==99999)
    return x("unknown");

  if (($val>=90000)&&($val<100000)) {
    return x("protocol")." ".xformat_proto($type,$val-90000);
  }
  if ($val < 100000)
    return x("tcp/").xformat_port($type,$val,6);
  
  if ($val < 200000)
    return x("udp/").xformat_port($type,$val-100000,17);

  if ($val < 300000)
    return x("icmp/").xformat_port($type,$val-200000,1);

  if (!is_array($cache_app_list)) {
    $cache_app_list=array();
    $res=SQL_query("SELECT id,name from x_app");
    if ($res) {
      while ($row=SQL_fetch_array($res))
        $cache_app_list[$row[0]+300000]=$row[1];
      SQL_free_result($res);
    }
  }

  if (($app=$cache_app_list[$val])) {
    if ($type==RESULT_GRAPH)
      return x("Application")."\n".$app;
    if ($type==RESULT_PLAIN)
      return x("Application")." ".$app;
    return x("Application")."<BR>".$app;
  }
  
  if ($type==RESULT_GRAPH)
    return x("Application")."\n".$val;

  if ($type==RESULT_PLAIN)
    return x("Application")." ".$val;
  return x("Application")."<BR>".$val;
}

function xformat_proto($type,$val) {
  global $drn;
  if ($drn)
    return $val;
  $proto=num2proto($val);
  if (!$proto) $proto=$val;
  return $proto;
}

function xformat_port($type,$val,$proto="6") {
  global $drn;
  if ($proto=="" || $drn)
    return $val;
    
  $protocol=num2proto($proto);
  $port=num2portdb($val,$protocol);
  if (is_numeric($port))
    $port="";
    
  if ($proto==1)
    $val=floor($val/256).".".($val%256);
  
  if ($type==RESULT_GRAPH)
    return $val."\n".$port;
  if ($type==RESULT_PLAIN)
    return $val." ".$port;
  return $val."<BR>".$port;
}

function get_iface_name($device_id,$ifindex) {
  $ret="";
  $v=SQL_escape(array($device_id,$ifindex));
  $res=SQL_query("SELECT name FROM x_iface WHERE did='$v[0]' AND ifindex='$v[1]'");
  if ($res) {
    if ($row=SQL_fetch_row($res)) 
      $ret=$row[0];
    SQL_free_result($res);
  }
  return $ret;
}

function xformat_interface($type,$iface,$rt="",$community="") {
  global $coll_id,$cache_iface_listc,$cache_iface_listr,$drn,$dsif;

  if (!$iface || $drn || (!$rt && !$coll_id))
    return x("ifIndex")." $iface";

   if ($rt) {
    if (!is_ip($rt))
      $rt=num2ip($rt);
    if (!$cache_iface_listr[$rt][$iface]) {
      $desc="";
      if ($community=="") {
        $res=SQL_query("SELECT id,snmp_community FROM x_device WHERE ip='".SQL_escape($rt)."' AND snmp_enabled=1");
        if ($res) {
          if ($row=SQL_fetch_row($res)) {
	    $did=$row[0];
	    $community=$row[1];
	  }
          SQL_free_result($res);
        }
      }
      if ($did)
	$desc=get_iface_name($did,$iface);
      if (is_ip($rt) && !$desc)
        $desc=@my_snmpget($rt,$community,".1.3.6.1.2.1.2.2.1.2.".$iface);
      $cache_iface_listr[$rt][$iface]=$desc;
    }
  }

  if ($coll_id) {
    if (!$cache_iface_listc[$coll_id][$iface]) {
      $desc="";
      $desc1="";
      $desc2="";
      $res=SQL_query("SELECT d.ip,d.snmp_community,d.id FROM x_device d, x_devcoll dc WHERE dc.id_c='".SQL_escape($coll_id)."' AND dc.id_d=d.id AND d.snmp_enabled=1");
      if ($res) {
        while  (($row=SQL_fetch_row($res))) {
	  $rt=$row[0];
	  $community=$row[1];
	  $did=$row[2];
          if ($did && !$desc1)
	    $desc1=get_iface_name($did,$iface);
	  if (is_ip($rt) && !$desc1 && !$desc2)
            $desc2=@my_snmpget($rt,$community,".1.3.6.1.2.1.2.2.1.2.".$iface);
        }
        SQL_free_result($res);
	$desc=($desc1)?"$desc1":"$desc2";
      }
      $cache_iface_listc[$coll_id][$iface]=$desc;
    }
  }
  
  $descc=$cache_iface_listc[$coll_id][$iface];
  $descr=$cache_iface_listr[$rt][$iface];
  $desc=($descr)?$descr:$descc;  
  if ($dsif) {
    if ($desc)
      return $desc;
    return x("ifIndex")." ".$iface;
  }
  if ($type==RESULT_GRAPH)
    return x("ifIndex")." ".$iface."\n".$desc;
  if ($type==RESULT_PLAIN)
    return x("ifIndex")." ".$iface;
  return x("ifIndex")." ".$iface."<BR>".$desc;
}


function xformat_as($type,$as) {
  global $drn;

  $asname="";
  if (!$drn) {
    $res=SQL_query("SELECT name from x_as_p WHERE asn='".SQL_escape($as)."'");
    if ($res) {
       if ($row=SQL_fetch_row($res))
	  $asname=$row[0];
       SQL_free_result($res);
    }
    if (!$asname) {
      $res=SQL_query("SELECT name from x_as WHERE asn='".SQL_escape($as)."'");
      if ($res) {
        if ($row=SQL_fetch_row($res))
	  $asname=$row[0];
        SQL_free_result($res);
      }
    }
  }

  if ($type==RESULT_GRAPH) {
    if ($asname)
      return "AS ".$as."\n".$asname;
    return "AS ".$as;
  }
  
  if ($type==RESULT_PLAIN)
    return "AS ".$as;
  if ($asname)
    return "AS ".$as."<br/>".$asname;
  return "AS ".$as;
}


function xformat_flags($type,$val) {
  $ret="";
  if (($val & 128)==128) $ret.="1";
  if (($val & 64)==64) $ret.="2";
  if (($val & 32)==32) $ret.="U";
  if (($val & 16)==16) $ret.="A";
  if (($val & 8)==8) $ret.="P";
  if (($val & 4)==4) $ret.="R";
  if (($val & 2)==2) $ret.="S";
  if (($val & 1)==1) $ret.="F";
  return $ret;
}

function xformat_tos($type,$val) {
  $flags1=""; $flags2="";
  $flags1.="P".($val>>5); /* precedence bits */
  if (($val&16) == 16)
    $flags1.="D";
  if (($val&8) == 8)
    $flags1.="T";
  if (($val&4) == 4)
    $flags1.="R";

  switch ($val&0xFC) { /* lowest 2bits are unused */
    case  0: $flags2="BE";	break;
    case 40: $flags2="AF11";	break;
    case 48: $flags2="AF12";	break;
    case 56: $flags2="AF13";	break;
    case 72: $flags2="AF21";	break;
    case 80: $flags2="AF22";	break;
    case 88: $flags2="AF23";	break;
    case 104: $flags2="AF31";	break;
    case 112: $flags2="AF32";	break;
    case 120: $flags2="AF33";	break;
    case 136: $flags2="AF41";	break;
    case 144: $flags2="AF42";	break;
    case 152: $flags2="AF43";	break;
    case 32: $flags2="CS1";	break;
    case 64: $flags2="CS2";	break;
    case 96: $flags2="CS3";	break;
    case 128: $flags2="CS4";	break;
    case 160: $flags2="CS5";	break;
    case 192: $flags2="CS6";	break;
    case 224: $flags2="CS7";	break;
    case 184: $flags2="EF";	break;
  }

  if ($flags2)
    return "$val [$flags1][$flags2]";
  return "$val [$flags1]";
}



function xformat_value($type,$val) {
  return $val;
}


function profile_save($profil_id,$type) {
  global $u_id,$u_name;

  if (!CheckRights("options")&&!CheckRights("profile")) {
    MsgError(x("You haven't right to create/modify profiles."));
    return;
  }
  if (!$profil_id) {
    $prof_name=$u_name." - ".strftime("%x %X",time());
    if (SQL_query("INSERT INTO x_profile (name,id_user,flag,type,comment,url) VALUES ('$prof_name','$u_id','local','$type','','".SQL_escape(args("",array('prof_save','profil_id')))."')")) {
      $res=SQL_query("SELECT LAST_INSERT_ID()");
      if ($res) {
	if ($row=SQL_fetch_row($res))
	  $profil_id=$row[0];
	SQL_free_result($res);
      }
      MsgInfo(x("Profile saved as '%s'.<br/>").ShowLink(x("Click to edit this profile."),PRG_PATH."src/profiles/$type?profil_id=".$profil_id),$prof_name);
    }
    else
      MsgError(x("Profile not saved. Query failed."));
  }
  else {
    if (CheckRights("options")) {
      if (SQL_query("UPDATE x_profile SET url='".SQL_escape(args("",array('prof_save','profil_id')))."' WHERE id='".SQL_escape($profil_id)."'"))
        MsgInfo(x("Profile updated.<br/>").ShowLink(x("Click to edit this profile."),PRG_PATH."src/profiles/$type?profil_id=".$profil_id));
      else
        MsgError(x("Profile not saved. Query failed."));
    }
    else {
      if (SQL_query("UPDATE x_profile SET url='".SQL_escape(args("",array('prof_save','profil_id')))."' WHERE id_user='".SQL_escape($u_id)."' AND id='".SQL_escape($profil_id)."'"))
        MsgInfo(x("Profile updated.<br/>").ShowLink(x("Click to edit this profile."),PRG_PATH."src/profiles/$type?profil_id=".$profil_id));
      else
        MsgError(x("Profile not saved. Query failed."));
    }

  }

}


function get_country_code($ip) {
  $code="";
  if (!is_ip($ip))
    $ip=ip2num($ip);
  $ip=SQL_escape($ip);
  $res=SQL_query("SELECT code FROM x_ip_cc_p WHERE ipn_s<='".$ip."' AND ipn_e>='".$ip."'");
  if ($res) {
    $row=SQL_fetch_array($res);
    $code=$row[0];
    SQL_free_result($res);
  }
  if ($code)
    return $code;
  $res=SQL_query("SELECT code FROM x_ip_cc WHERE ipn_s<='".$ip."' AND ipn_e>='".$ip."'");
  if ($res) {
    $row=SQL_fetch_array($res);
    $code=$row[0];
    SQL_free_result($res);
  }
  return $code;
}

function popup_script($width="300",$height="200",$options="",$append="yes") {
  global $u_java;

  if (!$u_java)
    return;

  if (!$options)
    $options="dependent=yes, menubar=no, location=no, resizable=no, width=$width, height=$height, toolbar=no, scrollbars=yes, left=100, top=100";
 
  echo "<SCRIPT language=\"JavaScript1.2\" type=\"text/javascript\">\n"; 
  echo "var MyValue;\n";
  echo "var MyWindow;\n";

  echo "function MyDialog(url,formname,inputfield,scriptvar) {\n";
  echo "  MyValue=eval('document.'+formname+'.'+inputfield);\n";
  echo "  if (MyValue != null) {\n";
  echo "    if (scriptvar != '')\n";
  echo "      MyWindow=window.open(url+'?'+scriptvar+'='+MyValue.value,\"MyDialog\",\"$options\");\n";
  echo "    else\n";
  echo "      MyWindow=window.open(url,\"MyDialog\",\"$options\");\n";
  echo "    if (MyWindow != null)\n";
  echo "      MyWindow.focus();\n";
  echo "  }\n";
  echo "}\n";

  echo "function Transfer(NewValue) {\n";
  if ($append=="yes") {
    echo "  if (MyValue.value != '')\n";
    echo "    MyValue.value=MyValue.value+','+NewValue;\n";
    echo "  else\n";
  }
  echo "    MyValue.value=NewValue;\n";
  echo "}\n";
  echo "</SCRIPT>\n";
}

function history_clear($grp) {
  global $u_id;

  $v=SQL_escape(array($u_id,$grp));
  $res=SQL_query("SELECT id from x_history WHERE id_user='$v[0]' AND grp='$v[1]' ORDER by time DESC");
  if ($res) {
    $i=0;
    while ($row=SQL_fetch_array($res)) {
      if ($i>30) /* keep only last 30 commands */
	SQL_query("DELETE FROM x_history WHERE id='".$row[0]."'"); 
      $i++;
    }
    SQL_free_result($res);
  }
}

function history_save($grp,$cmd) {
  global $u_id;

  $v=SQL_escape(array($u_id,$grp,time(),$cmd));
  SQL_query("DELETE FROM x_history WHERE id_user='$v[0]' AND grp='$v[1]' AND cmd='$v[3]'");
  history_clear($grp);
  SQL_query("INSERT INTO x_history (id_user,grp,time,cmd) VALUES ('$v[0]','$v[1]','$v[2]','$v[3]')");  
}


function history_load($grp) {
  global $u_id;
  $ret=array();

  $v=SQL_escape(array($u_id,$grp));
  $res=SQL_query("SELECT cmd FROM x_history WHERE id_user='$v[0]' AND grp='$v[1]' ORDER BY time DESC");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $ret[]=$row[0];
    SQL_free_result($res);
  }
  history_clear($grp);
  return $ret;
}


function show_java_dialog($url,$img,$field="",$alttext="") {
  global $u_java;
  if ($u_java)
    return ShowImageLink($alttext,$img,"#","onclick=\"MyDialog('$url','myform','$field','')\"");
  return '';
}


function show_history($grp,$field="") {
  if (!$field)
    $field=$grp;
  return show_java_dialog(PRG_PATH."src/data/history.php?grp=$grp",PRG_PATH.'images/ic_history.gif',$field,x("Command history"));
}

function show_listapp($field) {
  return show_java_dialog(PRG_PATH."src/data/listapp.php",PRG_PATH.'images/ic_list.gif',$field,x("List of applications"));
}

function show_listproto($field) {
  return show_java_dialog(PRG_PATH."src/data/listproto.php",PRG_PATH.'images/ic_list.gif',$field,x("List of protocols"));
}

function show_listiface($coll,$field) {
  return show_java_dialog(PRG_PATH."src/data/listiface.php?coll=$coll",PRG_PATH.'images/ic_list.gif',$field,x("List of interfaces"));
}

function show_listdev($coll,$field) {
  return show_java_dialog(PRG_PATH."src/data/listdev.php?coll=$coll",PRG_PATH.'images/ic_list.gif',$field,x("List of devices"));
}

function show_listcolor($field) {
  return show_java_dialog(PRG_PATH."src/options/listcolor.php",PRG_PATH.'images/ic_list.gif',$field,x("List of base colors"));
}

function is_portdb($portname,$proto="tcp") {
  $found=false;
  if (strstr($portname,"/")) {
    list($proto,$portname)=explode("/",$portname);
  }
  $proto=proto2num($proto);
  $v=SQL_escape(array($portname,$proto));
  $res=SQL_query("SELECT port FROM x_portname WHERE name='$v[0]' AND protocol='$v[1]'");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      $found=true;
    SQL_free_result($res);
  }
  if ($found)
    return true;
  return is_port($portname,$proto);
}

function port2numdb($portname,$proto="tcp") {
  $found=false;
  if (strstr($portname,"/")) {
    list($proto,$portname)=explode("/",$portname);
  }
  $proto=proto2num($proto);
  $v=SQL_escape(array($portname,$proto));
  $res=SQL_query("SELECT port FROM x_portname WHERE name='$v[0]' AND protocol='$v[1]'");
  if ($res) {
    if ($row=SQL_fetch_array($res)) {
      $port=$row[0];
      $found=true;
    }
    SQL_free_result($res);
  }
  if ($found)
    return $port;
  return port2num($portname,$proto);
}


function num2portdb($portnum,$proto="tcp") {
  $port="";
  $proto=proto2num($proto);
  $v=SQL_escape(array($portnum,$proto));
  $res=SQL_query("SELECT name FROM x_portname WHERE port='$v[0]' AND protocol='$v[1]'");
  if ($res) {
    if ($row=SQL_fetch_array($res))
      $port=$row[0];
    SQL_free_result($res);
  }
  if ($port)
    return $port;
  return num2port($portnum,$proto);
}

function restriction_colllist($list) {
  global $u_id_grp,$u_rights;

  if (strstr($u_rights,"admin"))
    return $list;

  $allow=array();
  $ret=array();
  $enable_all=0;
  $v=SQL_escape($u_id_grp);
  $res=SQL_query("SELECT id_coll FROM x_group_res WHERE id_group='$v'");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      $allow[$row[0]]="1";
      if ($row[0]==0)
       $enable_all=1;
    }
    SQL_free_result($res);
  }

  if ($enable_all || !count($allow))
    return $list;

/* return restricted collection */
  while (list($key,$val) = each($list))
    if ($allow[$key])
      $ret[$key]=$val;
  return $ret;
}

?>