<?php
define('HELPMARK','data_utilmap.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once('utillib.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('viewer',$viewer);

getGlobalVar('id',$id);
getGlobalVar('id_coll',$id_coll);
getGlobalVar('id_img',$id_img);
getGlobalVar('enabled',$enabled);
getGlobalVar('name',$name);
getGlobalVar('caption',$caption);
getGlobalVar('showcoll',$showcoll);
getGlobalVar('showtime',$showtime);
getGlobalVar('textclr',$textclr);
getGlobalVar('pathclr',$pathclr);
getGlobalVar('type',$type);
getGlobalVar('comment',$comment);

$comment=strip_lfcr($comment);

PageHead();
PageLogo();
MenuStart('data','MySubMenu');
PageTitle(x("Utilization maps"),'i_utilmap.gif');
demo_die();
RequireRights("utilmap");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','clear','view','viewall','clearall','flushall');

$list_coll=list_table("x_coll","ORDER BY name");
$list_img=list_table("x_imagestore","WHERE grp='_UTILIZATION_MAP' ORDER BY name");

$list_type['gif']='GIF';
$list_type['jpg']='JPEG';
$list_type['png']='PNG';

if (!is_array($list_coll) || count($list_coll)==0)
  MsgFatal(x("No collector is defined... Use Options->Collectors menu first."));

if (!is_array($list_img) || count($list_img)==0)
  MsgFatal(x("No background image is available... Use Options->Image Store menu first."));


if ($viewer) {
  FormStart();
  echo InputHidden("id",$id);
  echo InputHidden("id_coll",$id_coll);
  echo InputHidden("enabled",$enabled);
  echo InputHidden("name",$name);
  echo InputHidden("caption",$caption);
  echo InputHidden("showtime",$showtime);
  echo InputHidden("showcoll",$showcoll);
  echo InputHidden("textclr",$textclr);
  echo InputHidden("pathclr",$pathclr);
  echo InputHidden("type",$type);
  
  if ($command=="editsubmit")
    echo InputHidden("command","edit");
  else  
    echo InputHidden("command","add");
  
  WinStart(x("Background selector"));
  THItem(x("Image name"),'COLSPAN="2"');
  THItem(x("Image"));
  reset($list_img);
  while (list($key,$val) = each($list_img)) {
    TNext();
    TItem(InputRadio("id_img",$key,i_chk($id_img==$key)));
    TItem("<B>$val<B>");
    TItem(ShowImage($val,PRG_PATH."src/options/imagestore_i.php?id=".$key),'ALIGN="left"');
  }
  TNext();
  TItem("<BR>".InputSubmit("btn_save",x("Select")),'COLSPAN="3" ALIGN="center"');
  FormEnd();
  $command="viewer";
}

if ($command=="flushall") {
  $res=SQL_query("SHOW TABLES LIKE 'tmap%'");
  if ($res) {
    while ($row=SQL_fetch_array($res)) 
      SQL_query("DROP TABLE $row[0]");
    MsgInfo(x("All cached map tables were dropped."));
  }
  else
    MsgError(x("Database error."));
  $command="clearall";
}



if ($command=="clear") {
  $handle=opendir(PRG_EXPORTDIR);
  if ($handle) {
    while ($file = readdir($handle)) {
      if (is_file(PRG_EXPORTDIR.$file)&&ereg("map".$id."_[[:digit:]]+",$file))
        unlink(PRG_EXPORTDIR.$file);
    }
    closedir($handle);
  }
  MsgInfo(x("Cached map images were deleted."));
  $command="";
}

if ($command=="clearall") {
  $handle=opendir(PRG_EXPORTDIR);
  if ($handle) {
    while ($file = readdir($handle)) {
      if (is_file(PRG_EXPORTDIR.$file)&&ereg("map[[:digit:]]+_[[:digit:]]+",$file))
        unlink(PRG_EXPORTDIR.$file);
    }
    closedir($handle);
  }
  MsgInfo(x("All cached map images were deleted."));
  $command="";
}




if ($command=="view") {
  getGlobalVar('HTTPS',$https,PRG_SERVER);
  getGlobalVar('HTTP_HOST',$server_host,PRG_SERVER);
  getGlobalVar('SERVER_PORT',$server_port,PRG_SERVER);
  getGlobalVar('SCRIPT_NAME',$script_name,PRG_SERVER);
  $script_name=ereg_replace("utilmap.php","",$script_name);

  $fqdn='http';
  if($https=='on')
    $fqdn.='s';
  $fqdn.='://'.$server_host;
  if ($server_port && $server_port!=80)
    $fqdn.=":".$server_port;
  $fqdn.=$script_name;
  WinStart(x("Utilization map"));
  TItem(ShowImage("MAP_".$id,"utilimg.php?id=".$id));
  TNext();
  TItem(x("Web URL:")." ".ShowLink($fqdn."utilimg.php?id=".$id,$fqdn."utilimg.php?id=".$id,'','TARGET="info"'));
  WinEnd();
  $command="";
}

if ($command=="viewall") {
  $res=SQL_query("SELECT id,name FROM x_utilmap WHERE enabled=1 ORDER BY id");
  if ($res) {
    if ($num=SQL_num_rows($res)) {
      $i=0;
      while ($row=SQL_fetch_array($res)) {
	echo "<B>".x("Map")." $row[0] - $row[1]:</B><BR>";
        echo ShowImageLink("MAP_".$row[0],"utilimg.php?id=".$row[0],"utilimg.php?id=".$row[0],'','TARGET="info"');
	echo "<BR><BR><BR>\n";
	$i++;
      }
    }
    else
      MsgInfo(x("No rows found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}


if ($command=="addsubmit") {
    $v=SQL_escape(array($id_coll,$id_img,$enabled,$name,$caption,$showtime,$showcoll,$textclr,$pathclr,$type,$comment));
    if (!req_var($name,x("name")))
      $command="add";
    else
    if (!req_var($id_coll,x("collector")))
      $command="add";
    else
    if (SQL_query("INSERT INTO x_utilmap (id_coll,id_img,enabled,name,caption,showtime,showcoll,textclr,pathclr,type,comment) 
	VALUES('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]')")) {
      MsgInfo(x("Utilization map %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate name."));
      $command="add";
    }
}



if ($command=="editsubmit") {
    $v=SQL_escape(array($id,$id_img,$enabled,$name,$caption,$showtime,$showcoll,$textclr,$pathclr,$type,$comment));
    if (!req_var($name,x("name")))
      $command="edit";
    else
    if (SQL_query("UPDATE x_utilmap SET id_img='$v[1]',enabled='$v[2]',name='$v[3]',caption='$v[4]',
    showtime='$v[5]',showcoll='$v[6]',textclr='$v[7]',pathclr='$v[8]',type='$v[9]',comment='$v[10]' WHERE id='$v[0]'")) {
      MsgInfo(x("Utilization map %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate name."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_utilmap WRITE,x_utilobj WRITE,x_utilpth WRITE");

	$res=SQL_query("SELECT name FROM x_utilmap WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

	SQL_query("DELETE FROM x_utilpth WHERE id_map='$v'");
	SQL_query("DELETE FROM x_utilobj WHERE id_map='$v'");

        if (!SQL_query("DELETE FROM x_utilmap WHERE id='$v'")) {
	  MsgError(x("Delete failed. Utilization map %s wasn't deleted."),$name);
	  $error=1;
	}
	
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected utilization maps were deleted ...")); 
  }
  $command="";
}



if (($command=="add")||($command=="edit")) {
  getGlobalVar('HTTPS',$https,PRG_SERVER);
  getGlobalVar('HTTP_HOST',$server_host,PRG_SERVER);
  getGlobalVar('SERVER_PORT',$server_port,PRG_SERVER);
  getGlobalVar('SCRIPT_NAME',$script_name,PRG_SERVER);
  $script_name=ereg_replace("utilmap.php","",$script_name);

  $fqdn='http';
  if($https=='on')
    $fqdn.='s';
  $fqdn.='://'.$server_host;
  if ($server_port && $server_port!=80)
    $fqdn.=":".$server_port;
  $fqdn.=$script_name;

    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT id_coll,id_img,enabled,name,caption,showtime,showcoll,textclr,pathclr,type,comment FROM x_utilmap WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$id_coll=$row[0];
	$id_img=$row[1];
	$enabled=$row[2];
	$name=$row[3];
	$caption=$row[4];
	$showtime=$row[5];
	$showcoll=$row[6];
	$textclr=$row[7];
	$pathclr=$row[8];
	$type=$row[9];
	$comment=$row[10];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new utilization map"));
      TItem(x("Collector:"));
      TItem(InputSelect("id_coll",select_list($list_coll,$id_coll)));
      TNext();
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit utilization map"));
      TItem(x("Map ID:"));
      TItem("<B>$id</B> ".
    	    "[".ShowLink(x("Objects"),"utilobj.php?id_map=$id")."]&nbsp;&nbsp;".
	    "[".ShowLink(x("Paths"),"utilpth.php?id_map=$id")."]");
      TNext();
      TItem(x("Map URL:"));
      TItem($fqdn."utilimg.php?id=".$id);
      TNext();
      TItem(x("Collector:"));
      TItem("<B>$list_coll[$id_coll]</B>");
      TNext();
    }
    TItem(x("Map name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Map caption:"));
    TItem(Input("caption",$caption,64));
    TNext(); 
    TItem(x("Active:"));
    TItem(InputCheck("enabled","1",i_chk($enabled)));
    TNext();
    TItem(x("Background:"));
    TItem(InputSelect("id_img",select_list($list_img,$id_img)).InputSubmit("viewer",x("Viewer")));
    TNext();
    TItem(x("Show collector name:"));
    TItem(InputCheck("showcoll","1",i_chk($showcoll)));
    TNext();
    TItem(x("Show measurement time:"));
    TItem(InputCheck("showtime","1",i_chk($showtime)));
    TNext();
    TItem("Text color:");
    reset($img_colors);
    $colors='<TABLE CELLSPACING="0" CELLPADDING="0"><TR>';
    while (list($name,$val) = each($img_colors)) {
      $clr=sprintf("#%02X%02X%02X",$val[0],$val[1],$val[2]);
      $colors.="<TD BGCOLOR=\"$clr\">".InputRadio("textclr",$name,i_chk($name==$textclr))."</TD>";
    }
    $colors.='</TR></TABLE>';
    TItem($colors);
    TNext();
    TItem("Path color:");
    reset($img_colors);
    $colors='<TABLE CELLSPACING="0" CELLPADDING="0"><TR>';
    while (list($name,$val) = each($img_colors)) {
      $clr=sprintf("#%02X%02X%02X",$val[0],$val[1],$val[2]);
      $colors.="<TD BGCOLOR=\"$clr\">".InputRadio("pathclr",$name,i_chk($name==$pathclr))."</TD>";
    }
    $colors.='</TR></TABLE>';
    TItem($colors);
    TNext();
    TItem(x("Output format:"));
    TItem(InputSelect("type",select_list($list_type,$type)));
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    
    if ($command=="edit") {
      echo "<BR><BR>\n";
      WinStart(x("Stored map preview"));
      TItem(ShowImage("MAP_".$id,"utilimg.php?id=$id&show=1"));
      WinEnd();
    }
    FormEnd();
}



if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected utilization maps?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="") {
  $res=SQL_query("SELECT id,enabled,name,caption FROM x_utilmap ORDER BY name");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem();
      THItem(x("Name"));
      THItem(x("Caption"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	if ($row[1])
	  TItem(ShowImage(x("enabled"),PRG_PATH.'images/ic_gl.gif'));
	else
	  TItem(ShowImage(x("disabled"),PRG_PATH.'images/ic_rl.gif'));
	TItem($row[2]);
	TItem(str_strip($row[3]));
	TItem(ShowLink(x("Edit"),"utilmap.php?command=edit&id=$row[0]")."&nbsp;&nbsp;".
    	    "[".ShowLink(x("Objects"),"utilobj.php?id_map=$row[0]")."]&nbsp;&nbsp;".
	    "[".ShowLink(x("Paths"),"utilpth.php?id_map=$row[0]")."]&nbsp;&nbsp;".
	    "[".ShowLink(x("Clear cache"),"utilmap.php?command=clear&id=$row[0]")."]&nbsp;&nbsp;".
	    "[".ShowLink(x("View"),"utilmap.php?command=view&id=$row[0]")."]",'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="5" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No rows found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();




function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'utilmap.php');
  $mysubmenu[]=array('caption'=>x("View all"),'url'=>'utilmap.php?command=viewall');
  $mysubmenu[]=array('caption'=>x("Clear all"),'url'=>'utilmap.php?command=clearall');
  $mysubmenu[]=array('caption'=>x("Flush all"),'url'=>'utilmap.php?command=flushall');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'utilmap.php?command=add');
  MenuSub(x("Utilization map"),$mysubmenu);
}


?>