<?php
define('HELPMARK','config_anomalies.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once(PRG_PATH . 'src/data/slib.php'); /* due to parse_ip */
require_once(PRG_PATH . 'src/anomaly/modules.php');


getGlobalVar('command',$command);
getGlobalVar('enableall',$enableall);
getGlobalVar('disableall',$disableall);

getGlobalVar('cid',$cid);
getGlobalVar('na',$na);
getGlobalVar('local_ip',$local_ip);

getGlobalVar('p0',$p0);
getGlobalVar('p1',$p1);
getGlobalVar('p2',$p2);
getGlobalVar('p3',$p3);
getGlobalVar('p4',$p4);
getGlobalVar('p5',$p5);
getGlobalVar('p6',$p6);
getGlobalVar('p7',$p7);
getGlobalVar('p8',$p8);
getGlobalVar('p9',$p9);

getGlobalVar('i_cri',$i_cri);
getGlobalVar('i_urg',$i_urg);
getGlobalVar('i_imp',$i_imp);
getGlobalVar('i_war',$i_war);
getGlobalVar('i_inf',$i_inf);
getGlobalVar('e_cri',$e_cri);
getGlobalVar('e_urg',$e_urg);
getGlobalVar('e_imp',$e_imp);
getGlobalVar('e_war',$e_war);
getGlobalVar('e_inf',$e_inf);



PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Network anomalies - Collector settings"),'i_anomaly.gif');
RequireRights("options");

check_command('coll','collsave','module','modulesave','enable','disable');

demo_cmd("collsave");
demo_cmd("modulesave");
demo_cmd("enable");
demo_cmd("disable");

if ($enableall || $disableall)
  demo_die();

$list_coll=list_table("x_coll","ORDER BY name");

if (!is_array($list_coll)|| !count($list_coll))
  MsgFatal(x("No available collector. Go to menu Options-&gt;Collectors first."));

if (!is_array($na_mod) || !count($na_mod))
  MsgFatal(x("No available network anomaly module."));


if ($enableall) {
  $res=0;
  reset($na_mod);
  while (list($na,$val)=each($na_mod)) {
    $mod=$na_mod[$na];
    $p0=get_mod_default($mod,'p0def');
    $p1=get_mod_default($mod,'p1def');
    $p2=get_mod_default($mod,'p2def');
    $p3=get_mod_default($mod,'p3def');
    $p4=get_mod_default($mod,'p4def');
    $p5=get_mod_default($mod,'p5def');
    $p6=get_mod_default($mod,'p6def');
    $p7=get_mod_default($mod,'p7def');
    $p8=get_mod_default($mod,'p8def');
    $p9=get_mod_default($mod,'p9def');
    $i_cri=get_mod_default($mod,'severity_i',0);
    $i_urg=get_mod_default($mod,'severity_i',1);
    $i_imp=get_mod_default($mod,'severity_i',2);
    $i_war=get_mod_default($mod,'severity_i',3);
    $i_inf=get_mod_default($mod,'severity_i',4);
    $e_cri=get_mod_default($mod,'severity_e',0);
    $e_urg=get_mod_default($mod,'severity_e',1);
    $e_imp=get_mod_default($mod,'severity_e',2);
    $e_war=get_mod_default($mod,'severity_e',3);
    $e_inf=get_mod_default($mod,'severity_e',4);
    $v=SQL_escape(array($cid,$na,$p0,$p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9,$i_cri,$i_urg,$i_imp,$i_war,$i_inf,$e_cri,$e_urg,$e_imp,$e_war,$e_inf));
    if (!SQL_query("REPLACE x_na_cfg (cid,na,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,i_cri,i_urg,i_imp,i_war,i_inf,e_cri,e_urg,e_imp,e_war,e_inf) 
    VALUES ('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]','$v[11]',
	    '$v[12]','$v[13]','$v[14]','$v[15]','$v[16]','$v[17]','$v[18]','$v[19]','$v[20]','$v[21]')"))
      $res++;
  }
  if ($res)
      MsgError(x("Update failed."));
}

if ($disableall) {
  $v=SQL_escape(array($cid));
  if (!SQL_query("DELETE FROM x_na_cfg WHERE cid='$v[0]'"))
    MsgError(x("Update failed."));
}



if ($command=="enable") {
  if (isset($na) && isset($na_mod[$na])) {
    $mod=$na_mod[$na];
    $p0=get_mod_default($mod,'p0def');
    $p1=get_mod_default($mod,'p1def');
    $p2=get_mod_default($mod,'p2def');
    $p3=get_mod_default($mod,'p3def');
    $p4=get_mod_default($mod,'p4def');
    $p5=get_mod_default($mod,'p5def');
    $p6=get_mod_default($mod,'p6def');
    $p7=get_mod_default($mod,'p7def');
    $p8=get_mod_default($mod,'p8def');
    $p9=get_mod_default($mod,'p9def');
    $i_cri=get_mod_default($mod,'severity_i',0);
    $i_urg=get_mod_default($mod,'severity_i',1);
    $i_imp=get_mod_default($mod,'severity_i',2);
    $i_war=get_mod_default($mod,'severity_i',3);
    $i_inf=get_mod_default($mod,'severity_i',4);
    $e_cri=get_mod_default($mod,'severity_e',0);
    $e_urg=get_mod_default($mod,'severity_e',1);
    $e_imp=get_mod_default($mod,'severity_e',2);
    $e_war=get_mod_default($mod,'severity_e',3);
    $e_inf=get_mod_default($mod,'severity_e',4);
    $v=SQL_escape(array($cid,$na,$p0,$p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9,$i_cri,$i_urg,$i_imp,$i_war,$i_inf,$e_cri,$e_urg,$e_imp,$e_war,$e_inf));
    if (!SQL_query("REPLACE x_na_cfg (cid,na,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,i_cri,i_urg,i_imp,i_war,i_inf,e_cri,e_urg,e_imp,e_war,e_inf) 
    VALUES ('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]','$v[11]',
	    '$v[12]','$v[13]','$v[14]','$v[15]','$v[16]','$v[17]','$v[18]','$v[19]','$v[20]','$v[21]')"))
      MsgError(x("Update failed."));
  }
  else
    MsgError(x("Unknown module."));
}

if ($command=="disable") {
  if (isset($na) && isset($na_mod[$na])) {
    $v=SQL_escape(array($cid,$na));
    if (!SQL_query("DELETE FROM x_na_cfg WHERE cid='$v[0]' AND na='$v[1]'"))
      MsgError(x("Update failed."));
  }
  else
    MsgError(x("Unknown module."));
}



if ($command=="collsave") {
  if (!isset($list_coll[$cid]))
    MsgFatal(x("Unknown collector."));

  $error="";
  $x="";
  if ($local_ip=="")
    $error=x("No internal network IP address range specified.");
  parse_ip($x,'ip',$local_ip,'');

  if ($error)
    MsgError($error);
  else {
    $internal="(srct=1 AND ".ereg_replace('ip','src',$x).")OR(dstt=1 AND ".ereg_replace('ip','dst',$x).")";
    $v=SQL_escape(array($cid,$local_ip,$internal));
    if (!SQL_query("REPLACE x_na_opt (cid,type,opt,v1,v2) VALUES ('$v[0]',0,'internal_network','$v[1]','$v[2]')"))
      MsgError(x("Update failed. Query database error."));
    else
      MsgInfo(x("Collector options updated successfully."));
  }
}



if ($command=="modulesave") {
  if (!isset($list_coll[$cid]))
    MsgFatal(x("Unknown collector."));

  if (!isset($na_mod[$na]))
    MsgFatal(x("Unknown module."));

  $error="";
  $v=SQL_escape(array($cid,$na,$p0,$p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9,$i_cri,$i_urg,$i_imp,$i_war,$i_inf,$e_cri,$e_urg,$e_imp,$e_war,$e_inf));

  if (isset($na_mod[$na]['check']) && function_exists($na_mod[$na]['check']))
    $na_mod[$na]['check'](); /* check parameters */
  if (!$error) {
    $severity_max=$na_mod[$na]['severity_max'];
    if ($severity_max > 0 && (
	!is_numeric($i_cri) || $i_cri>$severity_max || $i_cri<-1 ||
	!is_numeric($i_urg) || $i_urg>$severity_max || $i_urg<-1 ||
	!is_numeric($i_imp) || $i_imp>$severity_max || $i_imp<-1 ||
	!is_numeric($i_war) || $i_war>$severity_max || $i_war<-1 ||
	!is_numeric($i_inf) || $i_inf>$severity_max || $i_inf<-1 ||
        !is_numeric($e_cri) || $e_cri>$severity_max || $e_cri<-1 ||
	!is_numeric($e_urg) || $e_urg>$severity_max || $e_urg<-1 ||
	!is_numeric($e_imp) || $e_imp>$severity_max || $e_imp<-1 ||
	!is_numeric($e_war) || $e_war>$severity_max || $e_war<-1 ||
	!is_numeric($e_inf) || $e_inf>$severity_max || $e_inf<-1) )
       $error=x("Occurrence can be in range <-1;$severity_max>.");
  }
  if ($error)
    MsgError($error);
  else {
    if (!SQL_query("REPLACE x_na_cfg (cid,na,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,i_cri,i_urg,i_imp,i_war,i_inf,e_cri,e_urg,e_imp,e_war,e_inf) 
    VALUES ('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]','$v[11]',
	    '$v[12]','$v[13]','$v[14]','$v[15]','$v[16]','$v[17]','$v[18]','$v[19]','$v[20]','$v[21]')"))
      MsgError(x("Update failed. Query database error."));
    else
      MsgInfo(x("Module options updated successfully."));
  }
}




if ($command=="coll" || $command=="collsave" || $command=="enable"||$command=="disable") {
  if (!isset($list_coll[$cid]))
    MsgFatal(x("Unknown collector."));

  FormStart();  
  echo InputHidden("cid",$cid);
  echo InputHidden("command","collsave");

  WinStart(x("Collector")." - ".$list_coll[$cid]);

  if ($command!="collsave") {
    $list_na_opt=na_get_opt($cid,"AND type='0' AND opt='internal_network'");
    $local_ip=$list_na_opt[0]['v1'];
  }

  $list_na_cfg=na_get_cfg($cid);
  $list_na_enable=array();
  foreach ($list_na_cfg as $na_cfg)
    $list_na_enable[$na_cfg['na']]=1;
 

  TItem(x("Internal network IP address range:"));
  TItem(Input("local_ip",$local_ip,"1024"));
  TNext();
  TItem("<br/>".InputSubmit("update",x("Update settings")),'COLSPAN="2"');
  TNext();

  echo "<td COLSPAN=\"2\">\n";

  echo "<br/>\n";
  echo ShowLink(x("Enable all"),"anomaly.php?command=coll&enableall=1&cid=$cid")." ";
  echo ShowLink(x("Disable all"),"anomaly.php?command=coll&disableall=1&cid=$cid")."<br/>\n";

  WinTStart();
  THItem(x("State"));
  THItem(x("Name"));
  THItem(x("Module"));
  reset($na_mod);
  while (list($key,$mod) = each($na_mod)) {
    $state=$list_na_enable[$key];
    if ($state) {
      $url= ShowLink(x("Configure"),"anomaly.php?command=module&cid=$cid&na=$key")." ".
    	    ShowLink(x("Disable"),"anomaly.php?command=disable&cid=$cid&na=$key");
    }
    else
      $url= ShowLink(x("Enable"),"anomaly.php?command=enable&cid=$cid&na=$key");
    TLine();
    TItem(($state)?ShowImage('',PRG_PATH.'images/ic_gl.gif'):ShowImage('',PRG_PATH.'images/ic_rl.gif'),'ALIGN="center"');
    TItem($mod['name']);
    TItem($url,'ALIGN="center"');
  }
  WinEnd();

  echo "</td>\n";
  WinEnd();
  FormEnd();
}



if ($command=="module" || $command=="modulesave") {
  if (!isset($list_coll[$cid]))
    MsgFatal(x("Unknown collector."));

  if (!isset($na_mod[$na]))
    MsgFatal(x("Unknown module."));

  FormStart();  
  echo InputHidden("cid",$cid);
  echo InputHidden("na",$na);
  echo InputHidden("command","modulesave");

  WinStart(x("Collector")." - ".$list_coll[$cid]." (".$na_mod[$na]['name']." ".x("module").")");
  echo "<td>\n";

  if (isset($na_mod[$na]['desc']) && $na_mod[$na]['desc']!="")
    Msg(MSGDLG_TIP,x("Module description"),$na_mod[$na]['desc']);

  /* load configuration from database */
  if ($command!="modulesave") {
    $v=SQL_escape($na);
    $list_na_cfg=na_get_cfg($cid,"AND na='$v'");
    $na_cfg=$list_na_cfg[0];
    $p0=$na_cfg['p0'];
    $p1=$na_cfg['p1'];
    $p2=$na_cfg['p2'];
    $p3=$na_cfg['p3'];
    $p4=$na_cfg['p4'];
    $p5=$na_cfg['p5'];
    $p6=$na_cfg['p6'];
    $p7=$na_cfg['p7'];
    $p8=$na_cfg['p8'];
    $p9=$na_cfg['p9'];
    $i_cri=$na_cfg['i_cri'];
    $i_urg=$na_cfg['i_urg'];
    $i_imp=$na_cfg['i_imp'];
    $i_war=$na_cfg['i_war'];
    $i_inf=$na_cfg['i_inf'];
    $e_cri=$na_cfg['e_cri'];
    $e_urg=$na_cfg['e_urg'];
    $e_imp=$na_cfg['e_imp'];
    $e_war=$na_cfg['e_war'];
    $e_inf=$na_cfg['e_inf'];
  }

  $na_md=$na_mod[$na];
  if ($na_md['severity_max']>0)
    $tmp_text.=" <-1;".$na_md['severity_max'].">";

  WinTStart();
  THItem(x("Severity"));
  THItem(x("Internal network"));
  THItem(x("External network"));
  TNext();

  TItem(x("Critical occurrence:").$tmp_text);
  TItem(Input("i_cri",$i_cri));
  TItem(Input("e_cri",$e_cri));
  TNext();
  TItem(x("Urgent occurrence:").$tmp_text);
  TItem(Input("i_urg",$i_urg));
  TItem(Input("e_urg",$e_urg));
  TNext();
  TItem(x("Important occurrence:").$tmp_text);
  TItem(Input("i_imp",$i_imp));
  TItem(Input("e_imp",$e_imp));
  TNext();
  TItem(x("Warning occurrence:").$tmp_text);
  TItem(Input("i_war",$i_war));
  TItem(Input("e_war",$e_war));
  TNext();
  TItem(x("Informational occurrence:").$tmp_text);
  TItem(Input("i_inf",$i_inf));
  TItem(Input("e_inf",$e_inf));
  WinEnd();

  echo "<br/><br/>\n";

  $num_param=0;
  for ($i=0;$i<=9;$i++) {
    $name='p'.$i.'name';
    $def='p'.$i.'def';
    $var='p'.$i;
    if (isset($na_md[$name])) {
      if ($num_param==0)
        WinStart(x("Module parameters"));
      else
        TNext();
      if (isset($na_md[$def]))
        TItem($na_md[$name].'<br/><font size="-2">[default: '.$na_md[$def].']</font>');
      else
        TItem($na_md[$name]);
      TItem(Input($var,$$var,255));
      $num_param++;
    }
  }
  if ($num_param)
    WinEnd();

  echo "<br/>\n";
  echo InputSubmit("update",x("Update settings"));

  echo "</td>\n";
  WinEnd();
  FormEnd();
}




if ($command=="") {
  WinTStart();
  THItem(x("State"));
  THItem(x("Collector"));
  THItem(x("Modules"));
  while (list($key,$val)=each($list_coll)) {
    $list_na_cfg=array();
    $list_na_cfg=na_get_cfg($key);
    if (count($list_na_cfg)) {
      if (count($list_na_cfg) == count($na_mod))
        $state=ShowImage(x('All modules enabled'),PRG_PATH.'images/ic_gl.gif');
      else
        $state=ShowImage(x('Some of modules enabled'),PRG_PATH.'images/ic_yl.gif');
      $enadis=ShowLink(x("Disable all"),"anomaly.php?command=&disableall=1&cid=$key");
    }
    else {
      $state=ShowImage(x('All modules disabled'),PRG_PATH.'images/ic_rl.gif');
      $enadis="";
    }
    TLine();
    TItem($state,'ALIGN="center"');
    TItem($val);
    TItem(
	ShowLink(x("Configure"),"anomaly.php?command=coll&cid=$key")." ".$enadis);
  }
  WinEnd();
}

MenuEnd();
PageTail();




/*  F U N C T I O N S  */



function MySubMenu() {
  global $command,$cid;
  if ($command=="module" || $command=="modulesave")
    $mysubmenu[]=array('caption'=>x("Edit collector"),'url'=>"anomaly.php?command=coll&cid=$cid");
  $mysubmenu[]=array('caption'=>x("Global"),'url'=>'anomaly_glb.php');
  $mysubmenu[]=array('caption'=>x("Collectors"),'url'=>'anomaly.php');
  $mysubmenu[]=array('caption'=>x("Exclusions"),'url'=>'anomaly_exl.php');
  MenuSub(x("Anomalies"),$mysubmenu);
}



function na_get_opt($cid,$where="") {
  $v=SQL_escape($cid);
  $list_opt=array();
  $res=SQL_query("SELECT * FROM x_na_opt WHERE cid='$v' $where");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $list_opt[]=$row;
    SQL_free_result($res);
  }
  return $list_opt;
}



function na_get_cfg($cid,$where="") {
  $v=SQL_escape($cid);
  $list_cfg=array();
  $res=SQL_query("SELECT * FROM x_na_cfg WHERE cid='$v' $where");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $list_cfg[]=$row;
    SQL_free_result($res);
  }
  return $list_cfg;
}



function get_mod_default($module,$var,$index="") {
  if (isset($module[$var])) {
    if (is_array($module[$var]))
      return $module[$var][$index]; 
    return $module[$var]; 
  }
  return "";
}



function set_mod_severity_def($module) {
  for ($i=0;$i<=4;$i++) {
    $name='sev'.$i.'i';
    global $$name;
    if (!$$name) {
      $x=explode(',',$module['severity_int']);
      $$name=$x[$i];
    }
    $name='sev'.$i.'e';
    global $$name;
    if (!$$name) {
      $x=explode(',',$module['severity_ext']);
      $$name=$x[$i];
    }
  }
}


?>