<?php
define('HELPMARK','config_collectors.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');


getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('subdupl',$subdupl);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('id_unit',$id_unit);
getGlobalVar('id_fwd',$id_fwd);
getGlobalVar('id_flt',$id_flt);
getGlobalVar('enabled',$enabled);
getGlobalVar('icompress',$icompress);
getGlobalVar('part',$part);
getGlobalVar('ffh',$ffh);
getGlobalVar('ffd',$ffd);
getGlobalVar('ffw',$ffw);
getGlobalVar('ffm',$ffm);
getGlobalVar('nh',$nh);
getGlobalVar('nd',$nd);
getGlobalVar('nw',$nw);
getGlobalVar('nm',$nm);
getGlobalVar('sd',$sd);
getGlobalVar('sw',$sw);
getGlobalVar('sm',$sm);
getGlobalVar('rfd',$rfd);
getGlobalVar('rfw',$rfw);
getGlobalVar('rfm',$rfm);
getGlobalVar('ctime',$ctime);
getGlobalVar('port',$port);
getGlobalVar('dev',$dev);
getGlobalVar('comment',$comment);

$comment=strip_lfcr($comment);



PageHead();
PageLogo();

$list_coll=list_table("x_coll","ORDER BY name");

$max_coll = license_request();

MenuStart('options','MySubMenu');
PageTitle(x("Collector settings"),'i_coll.gif');
RequireRights("options,collector");
$list_format=array();
$list_format['spec_bas']=x("*** Basic fields ***");    
$list_format['spec_hyb']=x("*** Hybrid Mode ***");    
$list_format['spec_bgp']=x("*** BGP router ***");    
$list_format['spec_sec']=x("*** Security ***");    
$list_format['sip']=x("Source IP address");
$list_format['dip']=x("Destination IP address");
$list_format['proto']=x("Protocol");
$list_format['app']=x("Application");
$list_format['sp']=x("Source port");
$list_format['dp']=x("Destination port");
$list_format['sif']=x("Source interface");
$list_format['dif']=x("Destination interface");
$list_format['sas']=x("Source AS");
$list_format['das']=x("Destination AS");
$list_format['smask']=x("Source masklen");
$list_format['dmask']=x("Destination masklen");
$list_format['nh']=x("Nexthop IP address");
$list_format['flags']=x("TCP flags");
$list_format['tos']=x("Type of service");
$list_format['ver']=x("NetFlow version");
$list_format['rt']=x("Device IP address");

$list_device=list_table("x_device","ORDER BY name");
$list_unit=list_table("x_unit","ORDER BY name");
$list_fwd=list_table("x_fwd","ORDER BY name");
$list_flt=list_table("x_filter","ORDER BY name");

$list_sd['3600']=x("60 minutes");
$list_sd['1800']=x("30 minutes");
$list_sd['600']=x("10 minutes");
$list_sw['86400']=x("24 hours");
$list_sw['43200']=x("12 hours");
$list_sw['21600']=x("6 hours");
$list_sm['86400']=x("24 hours");
$list_sm['43200']=x("12 hours");

$list_part['1']=x("Soft");
$list_part['2']=x("Hard");
$list_part['0']=x("Disable");

$list_ctime['0']=x("Disable");
$list_ctime['1']=x("Soft");
$list_ctime['2']=x("Hard");



demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");

if ($subdelete)
  $command="delete";

if ($subdupl)
  $command="add";

if ($command=="addsubmit") {
  $command="add";

  if ($max_coll < 0) { 
    MsgWarn(x("Corrupted license key or license can't be loaded."));
    check_command('delete','deletesubmit','restart');
  }
  elseif (is_array($list_coll) && $max_coll>0 && count($list_coll)>=$max_coll) {
    check_command('delete','deletesubmit','edit','editsubmit','restart');
  }
  else
    check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','restart');



  if (count($list_unit)==0)
    MsgFatal(x("No unit defined... Use Options->Units menu first."));

  if (is_array($ffh)&&count($ffh)) {
    $ffh1=array();
    while (list($key,$val)=each($ffh)) {
      if ($val=="spec_bas")
	$ffh1=array_merge($ffh1,array('sip','dip','proto','sp','dp','app','sif','dif','nh'));
      elseif ($val=="spec_hyb")
	$ffh1=array_merge($ffh1,array('sip','dip','proto','sp','dp','app','sif','dif','nh','rt'));
      elseif ($val=="spec_bgp")
	$ffh1=array_merge($ffh1,array('sip','dip','proto','sp','dp','app','sif','dif','nh','sas','das'));
      elseif ($val=="spec_sec")
	$ffh1=array_merge($ffh1,array('sip','dip','proto','sp','dp','app','sif','dif','nh','flags','tos'));
      else
	$ffh1[]=$val;
    }
    $ffh=array_unique($ffh1);
  }
  else
    $ffh=array('sip','dip','proto','sp','dp','app','sif','dif','nh');

  if (is_array($ffd)&&count($ffd)) {
    $ffd1=array();
    while (list($key,$val)=each($ffd)) {
      if ($val=="spec_bas")
	$ffd1=array_merge($ffd1,array('sip','dip','proto','sp','dp','app','sif','dif'));
      elseif ($val=="spec_hyb")
	$ffd1=array_merge($ffd1,array('sip','dip','proto','sp','dp','app','sif','dif','rt'));
      elseif ($val=="spec_bgp")
	$ffd1=array_merge($ffd1,array('sip','dip','proto','sp','dp','app','sif','dif','sas','das'));
      elseif ($val=="spec_sec")
	$ffd1=array_merge($ffd1,array('sip','dip','proto','sp','dp','app','sif','dif'));
      else
	$ffd1[]=$val;
    }
    $ffd=array_unique($ffd1);
  }
  else
    $ffd=array('sip','dip','proto','sp','dp','app','sif','dif');

  if (is_array($ffw)&&count($ffw)) {
    $ffw1=array();
    while (list($key,$val)=each($ffw)) {
      if ($val=="spec_bas")
	$ffw1=array_merge($ffw1,array('sip','dip','app'));
      elseif ($val=="spec_hyb")
	$ffw1=array_merge($ffw1,array('sip','dip','app'));
      elseif ($val=="spec_bgp")
	$ffw1=array_merge($ffw1,array('sip','dip','app','sas','das'));
      elseif ($val=="spec_sec")
	$ffw1=array_merge($ffw1,array('sip','dip','app'));
      else
	$ffw1[]=$val;
    }
    $ffw=array_unique($ffw1);
  }
  else
    $ffw=array('sip','dip','app');

  if (is_array($ffm)&&count($ffw)) {
    $ffm1=array();
    while (list($key,$val)=each($ffm)) {
      if ($val=="spec_bas")
	$ffm1=array_merge($ffm1,array('sip','dip'));
      elseif ($val=="spec_hyb")
	$ffm1=array_merge($ffm1,array('sip','dip'));
      elseif ($val=="spec_bgp")
	$ffm1=array_merge($ffm1,array('sip','dip','sas','das'));
      elseif ($val=="spec_sec")
	$ffm1=array_merge($ffm1,array('sip','dip'));
      else
	$ffm1[]=$val;
    }
    $ffm=array_unique($ffm1);
  }
  else
    $ffm=array('sip','dip');

  if ((in_array('sp',$ffh)||in_array('dp',$ffh)) && !in_array('proto',$ffh)) $ffh[]='proto';
  if ((in_array('sp',$ffd)||in_array('dp',$ffd)) && !in_array('proto',$ffd)) $ffd[]='proto';
  if ((in_array('sp',$ffw)||in_array('dp',$ffw)) && !in_array('proto',$ffw)) $ffw[]='proto';
  if ((in_array('sp',$ffm)||in_array('dp',$ffm)) && !in_array('proto',$ffm)) $ffm[]='proto';
  
  $chk_d=check_format_table($ffd,$ffh);
  $chk_w=check_format_table($ffw,$ffd);
  $chk_m=check_format_table($ffm,$ffd);
    
  $fh=implode(',',do_format_table($ffh));
  $fd=implode(',',do_format_table($ffd,$fh));
  $fw=implode(',',do_format_table($ffw,$fd));
  $fm=implode(',',do_format_table($ffm,$fd));
      
  $error=0;
  var_string($error,'name',x("name"));
  var_number($error,'port',x("port"),"",1024,65535);
  var_number($error,'nh',x("number of hourly tables"),3,0,99999);
  var_number($error,'nd',x("number of daily tables"),1,0,99999);
  var_number($error,'nw',x("number of weekly tables"),1,0,99999);
  var_number($error,'nm',x("number of monthly tables"),1,0,99999);
  var_number($error,'rfd',x("reduce factor for daily tables"),0);
  var_number($error,'rfw',x("reduce factor for weekly tables"),0);
  var_number($error,'rfm',x("reduce factor for monthly tables"),0);    
  var_special($error,$chk_d,x("You selected more daily table items than you specified in hourly table."));
  var_special($error,$chk_w,x("You selected more weekly table items than you specified in daily table."));
  var_special($error,$chk_m,x("You selected more monthly table items than you specified in daily table."));
    
  if (!$error) {
    $v=SQL_escape(array($name,$id_unit,$enabled,$icompress,$part,$fh,$fd,$fw,$fm,$port,$comment,$nh,$nd,$nw,$nm,$sd,$sw,$sm,$id_fwd,$id_flt,$rfd,$rfw,$rfm,$ctime));
    SQL_query("LOCK TABLES x_coll WRITE,x_devcoll WRITE");
    
    if (SQL_query("INSERT INTO x_coll (name,id_unit,enabled,icompress,part,fh,fd,fw,fm,port,comment,nh,nd,nw,nm,sd,sw,sm,id_fwd,id_flt,rfd,rfw,rfm,ctime) 
	VALUES('$v[0]','$v[1]','0','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]','$v[11]','$v[12]','$v[13]','$v[14]','$v[15]','$v[16]','$v[17]','$v[18]','$v[19]','$v[20]','$v[21]','$v[22]','$v[23]')")) {
      $id=0;
      $res=SQL_query("SELECT id FROM x_coll WHERE name='$v[0]'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$id=$row[0];
	SQL_free_result($res);
      }
      else
	MsgError(x("Collector %s created successfully, but device association failed!"),$name);
      
      if ($id && SQL_query("INSERT INTO x_devcoll (id_c,id_d) VALUES ".build_devquery($id,$dev))) {
	if ($enabled)
	  SQL_query("UPDATE x_coll SET enabled=1 WHERE id='$id'");
        MsgInfo(x("Collector %s created successfully ..."),$name);
      }
      else
	MsgError(x("Collector %s created successfully, but device association failed!"),$name);
      $command="";
    }
    else
      MsgError(x("Insert failed. Maybe you tried inserting duplicate name."));
    SQL_query("UNLOCK TABLES");
  }
}


if ($command=="restart") {
  if (SQL_query("UPDATE x_coll SET enabled='4' WHERE id='".SQL_escape($id)."'"))
    MsgInfo(x("Selected collector was restarted."));
  else
    MsgError(x("Selected collector was NOT restarted."));
  $command="";
}

if ($command=="editsubmit") {
  $command="edit";
  $error=0;
  var_string($error,'name',x("name"));
  var_number($error,'port',x("port"),"",1024,65535);
  var_number($error,'nh',x("number of hourly tables"),3,0,99999);
  var_number($error,'nd',x("number of daily tables"),1,0,99999);
  var_number($error,'nw',x("number of weekly tables"),1,0,99999);
  var_number($error,'nm',x("number of monthly tables"),1,0,99999);    
  var_number($error,'rfd',x("reduce factor for daily tables"),0);
  var_number($error,'rfw',x("reduce factor for weekly tables"),0);
  var_number($error,'rfm',x("reduce factor for monthly tables"),0);    

  if (!$error) {
    $v=SQL_escape(array($id,$name,$id_unit,$enabled,$icompress,$part,$port,$comment,$nh,$nd,$nw,$nm,$id_fwd,$id_flt,$rfd,$rfw,$rfm,$ctime));
    SQL_query("LOCK TABLES x_coll WRITE,x_devcoll WRITE");
    if (SQL_query("UPDATE x_coll SET name='$v[1]',id_unit='$v[2]',enabled='$v[3]',icompress='$v[4]',part='$v[5]',port='$v[6]',
	  comment='$v[7]',nh='$v[8]',nd='$v[9]',nw='$v[10]',nm='$v[11]',
	  id_fwd='$v[12]',id_flt='$v[13]',rfd='$v[14]',rfw='$v[15]',rfm='$v[16]',ctime='$v[17]' WHERE id='$v[0]'")) {
      if (!SQL_query("DELETE FROM x_devcoll WHERE id_c='$v[0]'")) {
	SQL_query("UPDATE x_coll SET enabled=0 WHERE id='$id'");      
        MsgError(x("Collector %s updated successfully, but devices associations update failed! Collector is disabled now."),$name);
      }
      else
      if (SQL_query("INSERT INTO x_devcoll (id_c,id_d) VALUES ".build_devquery($v[0],$dev)))
        MsgInfo(x("Collector %s updated successfully ..."),$name);
      else {
	SQL_query("UPDATE x_coll SET enabled=0 WHERE id='$id'");      
        MsgError(x("Collector %s updated successfully, but devices associations update failed! Collector is disabled now."),$name);      
      }
      $command="";
    }
    else
      MsgError(x("Update failed. Maybe you tried inserting duplicate name."));
    SQL_query("UNLOCK TABLES");
  }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id)
	SQL_query("UPDATE x_coll SET enabled=0 WHERE id='".SQL_escape($id)."'");
    }
    
    sleep(10); /* wait to end process */
    
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_coll WRITE,x_devcoll WRITE,x_table READ");
    
	$res=SQL_query("SELECT name FROM x_coll WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

	$res=SQL_query("SELECT name FROM x_table WHERE name like '_$v\_%%'");
	if ($res) {
          while (($row=SQL_fetch_row($res))) {
	    SQL_query("DROP TABLE IF EXISTS `$row[0]`");
	    SQL_query("DELETE FROM x_table WHERE name like '$row[0]'");
	  }
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_coll WHERE id='$v'")) {
	  MsgError(x("Delete failed. Collector %s wasn't deleted."),$name);
	  $error=1;
	}
	else {
	  SQL_query("DELETE FROM x_devcoll WHERE id_c='$v'");
	}
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected collectors were deleted ...")); 
  }
  $command="";
}




if ($command=="add") {
    FormStart();
    echo InputHidden("command","addsubmit");
    WinStart(x("Add new collector"));  
    TItem(x("Collector name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Unit:"));
    TItem(InputSelect("id_unit",select_list($list_unit,$id_unit)));
    TNext(); 
    TItem(x("Enabled:"));
    TItem(InputCheck("enabled","1",i_chk($enabled)));
    TNext();
    TItem(x("Port:"));
    TItem(Input("port",$port,5));
    TNext();
    TItem(x("Number of hourly tables:"));
    TItem(Input("nh",$nh,5));
    TNext();
    TItem(x("Number of daily tables:"));
    TItem(Input("nd",$nd,5));
    TNext();
    TItem(x("Number of weekly tables:"));
    TItem(Input("nw",$nw,5));
    TNext();
    TItem(x("Number of monthly tables:"));
    TItem(Input("nm",$nm,5));
    TNext(); 
    TItem(x("Compress index files:"));
    TItem(InputCheck("icompress","1",i_chk($icompress)));
    TNext(); 
    TItem(x("Correct unsynchronized time:"));
    TItem(InputSelect("ctime",select_list($list_ctime,$ctime)));
    TNext(); 
    TItem(x("Partitioning:"));
    TItem(InputSelect("part",select_list($list_part,$part)));
    TNext();
    TItem(x("Associated devices:"));
    TItem(InputSelect("dev[]",select_list(array(x("*** any device ***"))+$list_device,$dev),'multiple'));    
    TNext();
    TItem(x("Forwarding list:"));
    TItem(InputSelect("id_fwd",select_list(array(x("*** don't forward ***"))+$list_fwd,$id_fwd)));    
    TNext();
    TItem(x("Filtering list:"));
    TItem(InputSelect("id_flt",select_list(array(x("*** don't filter ***"))+$list_flt,$id_flt)));    
    
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<br/>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();

    echo "<BR><BR>\n";
    if (!is_array($ffh)) $ffh[]='default';
    if (!is_array($ffd)) $ffd[]='default';
    if (!is_array($ffw)) $ffw[]='default';
    if (!is_array($ffm)) $ffm[]='default';
    WinStart(x("Advanced - aggregations and table formats"));
    echo "<TD COLSPAN=\"2\">\n";
    MsgInfo(x("Aggregation steps and table formats can't be later modified!"));
    echo "</TD>\n";
    TNext();
    TItem(x("Daily table aggregation step:"));
    TItem(InputSelect("sd",select_list($list_sd,$sd)));    
    TNext();
    TItem(x("Daily table reduce factor [-1;20]:"));
    TItem(Input("rfd",$rfd,5));
    TNext();
    TItem(x("Weekly table aggregation step:"));
    TItem(InputSelect("sw",select_list($list_sw,$sw)));    
    TNext();
    TItem(x("Weekly table reduce factor [-1;20]:"));
    TItem(Input("rfw",$rfw,5));
    TNext();
    TItem(x("Monthly table aggregation step:"));
    TItem(InputSelect("sm",select_list($list_sm,$sm)));    
    TNext();
    TItem(x("Monthly table reduce factor [-1;20]:"));
    TItem(Input("rfm",$rfm,5));

    TNext();
    TItem(x("Hourly table format:"));
    TItem(InputSelect("ffh[]",select_list($list_format,$ffh),'multiple'));
    TNext();
    TItem(x("Daily table format:"));
    TItem(InputSelect("ffd[]",select_list($list_format,$ffd),'multiple'));
    TNext();
    TItem(x("Weekly table format:"));
    TItem(InputSelect("ffw[]",select_list($list_format,$ffw),'multiple'));
    TNext();
    TItem(x("Monthly table format:"));
    TItem(InputSelect("ffm[]",select_list($list_format,$ffm),'multiple'));
    WinEnd();
    FormEnd();
}


if ($command=="edit") {
    if (!$btn_save) {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,id_unit,enabled,icompress,part,fh,fd,fw,fm,port,comment,nh,nd,nw,nm,sd,sw,sm,id_fwd,id_flt,rfd,rfw,rfm,ctime FROM x_coll WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$id_unit=$row[1];
	$enabled=$row[2];
	$icompress=$row[3];
	$part=$row[4];
	$fh=$row[5];
	$fd=$row[6];
	$fw=$row[7];
	$fm=$row[8];
	$port=$row[9];
	$comment=$row[10];
	$nh=$row[11];
	$nd=$row[12];
	$nw=$row[13];
	$nm=$row[14];
	$sd=$row[15];
	$sw=$row[16];
	$sm=$row[17];
	$id_fwd=$row[18];
	$id_flt=$row[19];
	$rfd=$row[20];
	$rfw=$row[21];
	$rfm=$row[22];
	$ctime=$row[23];
        SQL_free_result($res);
	if (!$sd) $sd=3600;
	if (!$sw) $sw=86400;
	if (!$sm) $sm=86400;
      }
      $dev=array();
      $res=SQL_query("SELECT id_d FROM x_devcoll WHERE id_c='$v'");
      if ($res) {
        while ($row=SQL_fetch_array($res)) 
	  $dev[]=$row[0];
        SQL_free_result($res);
      }
    }
    
    if (is_array($dev) && count($dev)==0) $dev[]=0;
        
    $ffh=explode(',',$fh);
    $ffd=explode(',',$fd);
    $ffw=explode(',',$fw);
    $ffm=explode(',',$fm);

    FormStart();
    echo InputHidden("id",$id);
    echo InputHidden("fh",$fh);
    echo InputHidden("fd",$fd);
    echo InputHidden("fw",$fw);
    echo InputHidden("fm",$fm);
    echo InputHidden("sm",$sm);
    echo InputHidden("sw",$sw);
    echo InputHidden("sm",$sm);

    echo InputHidden("command","editsubmit");

    WinStart(x("Edit collector"));
    TItem(x("ID:"));
    TItem("<B>$id</B>");
    TNext();
    TItem(x("Collector name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Unit:"));
    TItem(InputSelect("id_unit",select_list($list_unit,$id_unit)));
    TNext(); 
    TItem(x("Enabled:"));
    TItem(InputCheck("enabled","1",i_chk($enabled)));
    TNext();
    TItem(x("Port:"));
    TItem(Input("port",$port,5));
    TNext();
    TItem(x("Number of hourly tables:"));
    TItem(Input("nh",$nh,5));
    TNext();
    TItem(x("Number of daily tables:"));
    TItem(Input("nd",$nd,5));
    TNext();
    TItem(x("Number of weekly tables:"));
    TItem(Input("nw",$nw,5));
    TNext();
    TItem(x("Number of monthly tables:"));
    TItem(Input("nm",$nm,5));    
    TNext(); 
    TItem(x("Compress index files:"));
    TItem(InputCheck("icompress","1",i_chk($icompress)));
    TNext(); 
    TItem(x("Correct unsynchronized time:"));
    TItem(InputSelect("ctime",select_list($list_ctime,$ctime)));
    TNext(); 
    TItem(x("Partitioning:"));
    TItem(InputSelect("part",select_list($list_part,$part)));
    TNext();
    TItem(x("Associated devices:"));
    TItem(InputSelect("dev[]",select_list(array(x("*** any device ***"))+$list_device,$dev),'multiple'));    
    TNext();
    TItem(x("Forwarding list:"));
    TItem(InputSelect("id_fwd",select_list(array(x("*** don't forward ***"))+$list_fwd,$id_fwd)));
    TNext();
    TItem(x("Filtering list:"));
    TItem(InputSelect("id_flt",select_list(array(x("*** don't filter ***"))+$list_flt,$id_flt)));    
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<br/>".InputSubmit("btn_save",x("Save"))." ".InputSubmit("subdupl",x("Duplicate")),'COLSPAN="2" ALIGN="center"');
    WinEnd();


    echo "<BR><BR>\n";
    WinStart(x("Advanced - aggregations and table formats"));
    
    echo "<TD COLSPAN=\"2\">\n";
    MsgInfo(x("Aggregation steps and table formats can't be modified!"));
    echo "</TD>\n";
    TNext();
    TItem(x("Daily table aggregation step:"));
    TItem($list_sd[$sd]);
    TNext();
    TItem(x("Daily table reduce factor [-1;20]:"));
    TItem(Input("rfd",$rfd,5));
    TNext();
    TItem(x("Weekly table aggregation step:"));
    TItem($list_sw[$sw]);
    TNext();
    TItem(x("Weekly table reduce factor [-1;20]:"));
    TItem(Input("rfw",$rfw,5));
    TNext();
    TItem(x("Monthly table aggregation step:"));
    TItem($list_sm[$sm]);
    TNext();
    TItem(x("Monthly table reduce factor [-1;20]:"));
    TItem(Input("rfm",$rfm,5));
    TNext();
    TItem(x("Hourly table format:"));
    TItem(text_format_table($ffh));
    TNext();
    TItem(x("Daily table format:"));
    TItem(text_format_table($ffd));
    TNext();
    TItem(x("Weekly table format:"));
    TItem(text_format_table($ffw));
    TNext();
    TItem(x("Monthly table format:"));
    TItem(text_format_table($ffm));
    WinEnd();

    FormEnd();
}



if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected collectors? Don't break remove process. This action will take 10 seconds at minimum."));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,id_unit,name,enabled,port,comment FROM x_coll ORDER BY id_unit,name");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem("");
      THItem(x("Unit"));
      THItem(x("Name"));
      THItem(x("Port"));
      THItem(x("Comment"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	if ($row[3])
	  TItem(ShowImage(x("enabled"),PRG_PATH.'images/ic_gl.gif'));
	else
	  TItem(ShowImage(x("disabled"),PRG_PATH.'images/ic_rl.gif'));
	TItem($list_unit[$row[1]]);
	TItem($row[2]);
	TItem($row[4]);
	TItem(str_strip($row[5]));
	TItem(ShowLink(x("Edit"),"colls.php?command=edit&id=$row[0]").
	      '&nbsp;&nbsp;'.ShowLink(x("Restart"),"colls.php?command=restart&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<br/>".InputSubmit("subdelete",x("Delete")),'COLSPAN="7" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No collector found ... Please, click on the 'Add' link in the left 'Collectors' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  global $list_coll,$max_coll;
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'colls.php');
  if (!is_array($list_coll) || $max_coll==0 || count($list_coll)<$max_coll)
    $mysubmenu[]=array('caption'=>x("Add"),'url'=>'colls.php?command=add&enabled=1');
  MenuSub(x("Collectors"),$mysubmenu);
}



function do_format_table($f,$max="") {
  $fmt=array();
  foreach ($f as $field) {
    switch ($field) {
      case "sip":	if ($max==""||strstr($max,"sip")) $fmt[]="sip"; break;
      case "dip":	if ($max==""||strstr($max,"dip")) $fmt[]="dip"; break;
      case "sp":	if ($max==""||strstr($max,"sp")) $fmt[]="sp"; break;
      case "dp":	if ($max==""||strstr($max,"dp")) $fmt[]="dp"; break;
      case "proto":	if ($max==""||strstr($max,"proto")) $fmt[]="proto"; break;
      case "app":	if ($max==""||strstr($max,"app")) $fmt[]="app"; break;
      case "app":	if ($max==""||strstr($max,"app")) $fmt[]="app"; break;
      case "sif":	if ($max==""||strstr($max,"sif")) $fmt[]="sif"; break;
      case "dif":	if ($max==""||strstr($max,"dif")) $fmt[]="dif"; break;
      case "sas":	if ($max==""||strstr($max,"sas")) $fmt[]="sas"; break;
      case "das":	if ($max==""||strstr($max,"das")) $fmt[]="das"; break;
      case "smask":	if ($max==""||strstr($max,"smask")) $fmt[]="smask"; break;
      case "dmask":	if ($max==""||strstr($max,"dmask")) $fmt[]="dmask"; break;
      case "nh":	if ($max==""||strstr($max,"nh")) $fmt[]="nh"; break;
      case "flags":	if ($max==""||strstr($max,"flags")) $fmt[]="flags"; break;
      case "tos":	if ($max==""||strstr($max,"tos")) $fmt[]="tos"; break;
      case "ver":	if ($max==""||strstr($max,"ver")) $fmt[]="ver"; break;
      case "rt":	if ($max==""||strstr($max,"rt")) $fmt[]="rt"; break;
      case "default":	break;
    }
  }
  return array_unique($fmt);
}


function check_format_table($format,$prev) {
  if (is_array($format))
    $high=$format;
  else
    $high=explode(',',$format);
  if (is_array($prev))
    $low=$prev;
  else
    $low=explode(',',$prev);
  unset($high['default']);
  unset($low['default']);
  return count(array_diff($high,$low));
}


function text_format_table($fft) {
  global $list_format;
  
  foreach ($fft as $f) {
    if ($list_format[$f]) {
      if ($tf)
        $tf.=', '.$list_format[$f];
      else
        $tf=$list_format[$f];
    }
    $tf=wordwrap($tf,80,"<BR>\n");
  }
  return $tf;
}


function build_devquery($id,$dev) {
  $devquery="";
  if (is_array($dev)) {
    foreach ($dev as $dev_i) {
      if ($devquery)
        $devquery.=",('$id','".SQL_escape($dev_i)."')";
      else
        $devquery="('$id','".SQL_escape($dev_i)."')";	
    }
  }
  else
    return "('$id','".SQL_escape($dev)."')";
  return $devquery;
}


?>