<?php
define('HELPMARK','config_devices.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('ip',$ip);
getGlobalVar('snmp',$snmp);
getGlobalVar('snmp_community',$snmp_community);
getGlobalVar('sampling',$sampling);
getGlobalVar('sampling_rate',$sampling_rate);
getGlobalVar('resampling_rate',$resampling_rate);
getGlobalVar('comment',$comment);
getGlobalVar('autocoll',$autocoll);

$comment=strip_lfcr($comment);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Device settings"),'i_device.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','ping','snmp');

demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");
demo_cmd("ping");
demo_cmd("snmp");


if ($command=="addsubmit") {
    if ($sampling=="auto")
      $sampling_rate=0;      
    $v=SQL_escape(array($name,$ip,$snmp,$snmp_community,$sampling,$sampling_rate,$resampling_rate,$comment,$autocoll));
    if (!req_var($name,x("name")))
      $command="add";
    else
    if (!is_ip($ip)) {
      MsgError(x("Not valid IP address format."));
      $command="add";
    }
    else
    if (SQL_query("INSERT INTO x_device (name,ip,snmp_enabled,snmp_community,sampling,sampling_rate,resampling_rate,comment,autocoll) 
	VALUES('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]')")) {
      MsgInfo(x("Device %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate name."));
      $command="add";
    }
}


if ($command=="editsubmit") {
    if ($sampling=="auto")
      $sampling_rate=0;
    $v=SQL_escape(array($id,$name,$ip,$snmp,$snmp_community,$sampling,$sampling_rate,$resampling_rate,$comment,$autocoll));
    if (!req_var($name,x("name")))
      $command="edit";
    else
    if (!is_ip($ip)) {
      MsgError(x("Not valid IP address format."));
      $command="edit";
    }
    else
    if (SQL_query("UPDATE x_device SET name='$v[1]',ip='$v[2]',snmp_enabled='$v[3]',snmp_community='$v[4]',
	sampling='$v[5]',sampling_rate='$v[6]',resampling_rate='$v[7]',comment='$v[8]',autocoll='$v[9]' WHERE id='$v[0]'")) {
      MsgInfo(x("Device %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate name."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_device WRITE,x_devcoll WRITE");
    
	$res=SQL_query("SELECT name FROM x_device WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }
	
	SQL_query("DELETE FROM x_devcoll WHERE id_d='$v'");
	
        if (!SQL_query("DELETE FROM x_device WHERE id='$v'")) {
	  MsgError(x("Delete failed. Device %s wasn't deleted."),$name);
	  $error=1;
	}
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected devices were deleted ...")); 
  }
  $command="";
}



if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,ip,snmp_enabled,snmp_community,sampling,sampling_rate,resampling_rate,comment,autocoll FROM x_device WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$ip=$row[1];
	$snmp=$row[2];
	$snmp_community=$row[3];
	$sampling=$row[4];
	$sampling_rate=$row[5];
	$resampling_rate=$row[6];
	$comment=$row[7];
	$autocoll=$row[8];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new device"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit device"));
      TItem(x("ID:"));
      TItem("<B>$id</B>");
      TNext();
    }

    $list_sampling=array();
    $list_sampling['auto']=x("Autodetect");
    $list_sampling['manual']=x("Use sampling rate");
    
    TItem(x("Device name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("IP address:"));
    TItem(Input("ip",$ip,255));
    TNext(); 
    TItem(x("SNMP access:"));
    TItem(InputCheck("snmp","1",i_chk($snmp)));
    TNext();
    TItem(x("SNMP community:"));
    TItem(Input("snmp_community",$snmp_community,255));
    TNext();    
    TItem(x("Sampling:"));
    TItem(InputSelect("sampling",select_list($list_sampling,$sampling)));
    TNext();    
    TItem(x("Sampling rate:"));
    TItem(Input("sampling_rate",$sampling_rate,5));
    TNext();    
    TItem(x("Resampling rate:"));
    TItem(Input("resampling_rate",$resampling_rate,5));
    TNext();    
    TItem(InputCheck("autocoll","1",i_chk($autocoll)).x("Automatically create new collectors"),'COLSPAN="2"');
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected devices?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="ping") {
  show_ping($ip);
  $command="";
}

if ($command=="snmp") {
  show_snmp($ip,$snmp_community);
  $command="";
}

if ($command=="") {
  $res=SQL_query("SELECT id,name,ip,snmp_enabled,snmp_community,comment FROM x_device");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("IP address"));
      THItem(x("SNMP"));
      THItem(x("Comment"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[1]);
	TItem(ShowLink(str_strip($row[2]),"devices.php?command=ping&ip=$row[2]"));
	if ($row[2] && $row[3])
	  TItem(x("Yes")." (".ShowLink(x("check it"),"devices.php?command=snmp&ip=$row[2]&snmp_community=$row[4]").")");
	else
	  TItem(x("No"));  
	TItem(str_strip($row[5]));
	$addone="";
	if ($row[2] && $row[3]) {
	  $addone=
		"&nbsp;&nbsp;".ShowLink(x("Interfaces"),"devices_if.php?id=$row[0]").
		"&nbsp;&nbsp;".ShowLink(x("Config file"),"devices_gc.php?id=$row[0]");
	}
	TItem(ShowLink(x("Edit"),"devices.php?command=edit&id=$row[0]").$addone,'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No device found ... Please, click on the 'Add' link in the left 'Devices' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  global $command,$id;

  $mysubmenu[]=array('caption'=>x("List"),'url'=>'devices.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'devices.php?command=add');
  if ($command=="edit")
    $mysubmenu[]=array('caption'=>x("Interfaces"),'url'=>"devices_if.php?did=$id");
  $mysubmenu[]=array('caption'=>x("Discover"),'url'=>'devices_dc.php');
  MenuSub(x("Devices"),$mysubmenu);
}


?>