<?php
define('HELPMARK','config_devices.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('btn_save',$btn_save);


getGlobalVar('ip_s',$ip_s);
getGlobalVar('ip_e',$ip_e);
getGlobalVar('step',$step);
getGlobalVar('community',$community);


PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Discover devices"),'i_device.gif');
RequireRights("options");

demo_die();

if (!$step || !is_numeric($step))
  $step=1;

if (!$btn_save) {
  MsgInfo(x("Discover devices process can check 256 IP address at maximum."));
}


FormStart();
popup_script("450","500",'','no');

WinStart(x("Discover devices parameters"));
TItem(x("Start IP address:"));
TItem(Input("ip_s",$ip_s,255).show_history("ip_dev","ip_s"));
TNext();
TItem(x("End IP address:"));
TItem(Input("ip_e",$ip_e,255).show_history("ip_dev","ip_e"));
TNext();
TItem(x("Discovering step:"));
TItem(Input("step",$step,8));
TNext();
TItem(x("SNMP community:"));
TItem(Input("community",$community,255));
TNext(); 
TItem("<BR>".InputSubmit("btn_save",x("Discover")),'COLSPAN="2" ALIGN="center"');
WinEnd();
FormEnd();

$find=array();
if ($btn_save) {
  $ipn_s=ip2num($ip_s);
  $ipn_e=ip2num($ip_e);

  if ($ipn_s>$ipn_e) {
    $x=$ipn_s;
    $ipn_s=$ipn_e;
    $ipn_e=$x;
  }

  if (!is_ip($ip_s)) {
    MsgError(x("Start IP address is required.")); 
    $btn_save="";
  }
  elseif (!is_ip($ip_e)) {
    MsgError(x("End IP address is required.")); 
    $btn_save="";
  }
  elseif (($ipn_e-$ipn_s)/$step > 256) {
    MsgError(x("Many IP address for discovering. Discover supports 256 address at maximum.")); 
    $btn_save="";    
  }
  else {
    history_save("ip_dev",$ip_s);
    history_save("ip_dev",$ip_e);
    for ($ipn=$ipn_s;$ipn<=$ipn_e;$ipn+=$step) {
      $ip=num2ip($ipn);
      $sysName = @my_snmpwalk($ip,$community,".1.3.6.1.2.1.1.5","500000","1");
      if (count($sysName)) {
	$netflow_str="";
	$netflow = @my_snmpwalk_keys($ip,$community,".1.3.6.1.4.1.9.9.226.1.1.2.1.4.1.4","300000","1");
	if (count($netflow)) {
	  while (list($key,$val) = each($netflow)) {
	    $data=explode(".",$key);
	    $cnt=count($data);
	    if ($netflow_str)
	      $netflow_str.="<BR>";
	    $netflow_str.=$data[$cnt-5].".".$data[$cnt-4].".".$data[$cnt-3].".".$data[$cnt-2].":".$data[$cnt-1];
	  } 
	}
	$find[]=array($ip,$sysName[0],$netflow_str);
      }
      else
	$find[]=$ip;
    }
  }
}

if ($btn_save) {
  if (count($find)) {
    WinStart(x("Discovered devices"));
    THItem(x("IP address"));
    THItem(x("Hostname"));
    THItem(x("Device name"));
    THItem(x("NetFlow Export"));
    THItem(x("Command"));
    foreach ($find as $dev) {
      if (is_array($dev)) {
        $hostname=gethostbyaddr_cache($dev[0]);
        $link="ip=".urlencode($dev[0])."&name=".urlencode($dev[1])."&snmp=1&snmp_community=".urlencode($community)."&comment=$hostname&autocoll=1";
        TLine();
        TItem($dev[0]);
        TItem($hostname);
        TItem($dev[1]);
        if ($dev[2])
	  TItem($dev[2]);
        else
	  TItem(x("not found"));
        TItem(ShowLink(x("Add"),"devices.php?command=add&".$link,'','TARGET="adddev"'),'ALIGN="center"');
      }
      else {
        $hostname=gethostbyaddr_cache($dev);
        TLine();
        TItem($dev);
        TItem($hostname);
        TItem(x('*** no answer ***'));
    	TItem('');
        TItem('');
      }
    }
    WinEnd();
  }
  else
    MsgInfo(x("No devices discovered..."));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'devices.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'devices.php?command=add');
  $mysubmenu[]=array('caption'=>x("Discover"),'url'=>'devices_dc.php');
  MenuSub(x("Devices"),$mysubmenu);
}


?>