<?php
define('HELPMARK','status_collectors.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);

getGlobalVar('id',$id);
getGlobalVar('unit',$unit);

PageHead();
PageLogo();
MenuStart('status');
PageTitle(x("Collectors status"),'i_coll.gif');
RequireRights("status");

check_command('detail');


if ($command=="detail") {
  $list_coll=list_table("x_coll","ORDER by name");
  FormStart();
  echo InputHidden("command","detail");
  WinTStart();  
  TItem(x("Collector:").' '.InputSelect("id",select_list($list_coll,$id),($u_java)?"onchange=\"this.form.submit();\"":"").' '.
	    InputSubmit("send",x("Select")));
  WinEnd();
  FormEnd();

  if (!is_numeric($id))
    MsgFatal(x("Bad or unsupported ID"));

  $res=SQL_query("SELECT name,id_unit,id_db FROM x_coll WHERE id='".SQL_escape($id)."'");
  if ($res) {
    if (($row=SQL_fetch_array($res)))
      $name=$row[0];
      $id_unit=$row[1];
      $id_db=$row[2];
    SQL_free_result($res);
  }
    
  $c_stat=stat_getdetail("c$id");
  $r_stat=stat_getdetail("c$id",""," and access>=from_unixtime(unix_timestamp()-25)");

  if (!$c_stat[0][0])
    MsgFatal(x("Collector never started !!!"));
  if (!$r_stat[0][0])
    MsgWarn(x("Collector is NOT running at this moment..."));

  $cur_hour=floor(time()/3600)*3600;
  $start_time=$cur_hour;

  for ($i=0;$i<count($c_stat);$i++)
    if ($c_stat[$i][1]=="start")
      $start_time=$c_stat[$i][2];

  if ($start_time < $cur_hour)
    $period=(time()-$cur_hour)%3600;
  else
    $period=(time()-$start_time)%3600;

  $speriod=time()-$start_time;

  if ($period<1) $period=1;
  if ($speriod<1) $speriod=1;

  WinStart(x("Collector")." ".$name);    
  show_stat_time($c_stat,"start",x("Start time:"));
  WinEnd();

  echo "<BR><BR>\n";

  WinStart(x("Collector")." ".$name." (".x("current hour").")");
  THItem("");
  THITem(x("Suma"),'align="right"');
  THITem(x("Avg. per sec"),'align="right"');
  show_stat_val($c_stat,"num_bytes_hour",x("Number of bytes:"),$period);
  show_stat_val($c_stat,"num_pcks_hour",x("Number of packets:"),$period);
  show_stat_val($c_stat,"num_fwd_hour",x("Forwarded packets:"),$period);
  show_stat_val($c_stat,"num_flows_hour",x("Number of flows:"),$period);
  show_stat_val($c_stat,"num_rows_hour",x("Number of rows:"),$period);
  show_stat_val($c_stat,"num_flen_min_hour",x("Minimal flow length in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flen_avg_hour",x("Average flow length in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flen_max_hour",x("Maximal flow length in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flat_min_hour",x("Minimal flow export latency in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flat_avg_hour",x("Average flow export latency in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flat_max_hour",x("Maximal flow export latency in seconds:"),$period,-1,0);
  show_stat_val($c_stat,"num_flat_future_hour",x("Number of flows with end time in the future:"),$period,"0");
  show_stat_val($c_stat,"num_filter_hour",x("Number of filtered flows:"),$period); 
  show_stat_val($c_stat,"num_filter_allow_hour",x("Number of filtered flows (allowed):"),$period); 
  show_stat_val($c_stat,"num_filter_deny_hour",x("Number of filtered flows (denied):"),$period); 
  show_stat_val($c_stat,"num_filter_modify_hour",x("Number of filtered flows (modified):"),$period); 
  show_stat_val($c_stat,"num_badsrc_hour",x("Dropped packets due to bad source IP:"),$period,"0");
  show_stat_val($c_stat,"num_badver_hour",x("Dropped packets due to unsupported netflow version:"),$period,"0");
  show_stat_val($c_stat,"num_badflows_hour",x("Dropped flows due to corrupted data:"),$period,"0"); 
  show_stat_val($c_stat,"num_fullbuf_hour",x("Dropped flows due to full buffer:"),$period,"0"); 
  show_stat_val($c_stat,"num_fullbufb_hour",x("Dropped flow bytes due to full buffer:"),$period,"0"); 
  show_stat_val($c_stat,"num_fullbufp_hour",x("Dropped flow packets due to full buffer:"),$period,"0"); 
  show_stat_val($c_stat,"num_badtime_hour",x("Dropped flows due to corrupted time:"),$period,"0"); 
  show_stat_val($c_stat,"num_cbadtime_hour",x("Corrected flows due to corrupted time:"),$period); 

  WinEnd();

  echo "<BR><BR>\n";
 
  WinStart(x("Collector")." ".$name." (".x("summary").")");
  THItem("");
  THITem(x("Suma"),'align="right"');
  THITem(x("Avg. per sec"),'align="right"');
  show_stat_val($c_stat,"num_bytes",x("Number of bytes:"),$speriod);
  show_stat_val($c_stat,"num_pcks",x("Number of packets:"),$speriod);
  show_stat_val($c_stat,"num_fwd",x("Forwarded packets:"),$speriod);
  show_stat_val($c_stat,"num_flows",x("Number of flows:"),$speriod);
  show_stat_val($c_stat,"num_rows",x("Number of rows:"),$speriod);
  show_stat_val($c_stat,"num_flen_min_hour",x("Minimal flow length in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flen_avg_hour",x("Average flow length in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flen_max_hour",x("Maximal flow length in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flat_min_hour",x("Minimal flow export latency in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flat_avg_hour",x("Average flow export latency in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flat_max_hour",x("Maximal flow export latency in seconds:"),$speriod,-1,0);
  show_stat_val($c_stat,"num_flat_future_hour",x("Number of flows with end time in the future:"),$speriod);
  show_stat_val($c_stat,"num_filter",x("Number of filtered flows:"),$speriod); 
  show_stat_val($c_stat,"num_filter_allow",x("Number of filtered flows (allowed):"),$speriod); 
  show_stat_val($c_stat,"num_filter_deny",x("Number of filtered flows (denied):"),$speriod); 
  show_stat_val($c_stat,"num_filter_modify",x("Number of filtered flows (modified):"),$speriod);
  show_stat_val($c_stat,"num_badsrc",x("Dropped packets due to bad source IP:"),$speriod);
  show_stat_val($c_stat,"num_badver",x("Dropped packets due to unsupported netflow version:"),$speriod);
  show_stat_val($c_stat,"num_badflows",x("Dropped flows due to corrupted data:"),$speriod);
  show_stat_val($c_stat,"num_fullbuf",x("Dropped flows due to full buffer:"),$speriod);
  show_stat_val($c_stat,"num_fullbufb",x("Dropped bytes due to full buffer:"),$speriod);
  show_stat_val($c_stat,"num_fullbufp",x("Dropped packets due to full buffer:"),$speriod);
  show_stat_val($c_stat,"num_badtime",x("Dropped flows due to corrupted time:"),$speriod);
  show_stat_val($c_stat,"num_cbadtime",x("Corrected flows due to corrupted time:"),$speriod);
  Winend();
 
  echo "<BR><BR>\n";
  echo ShowLink(x("View unit used by current collector"),"units.php?command=detail&id=$id_unit");
}

if ($command=="") {
  if ($unit && is_numeric($unit)) 
    $res=SQL_query("SELECT id,name,enabled FROM x_coll WHERE id_unit='".SQL_escape($unit)."'ORDER BY name");
  else
    $res=SQL_query("SELECT id,name,enabled FROM x_coll ORDER BY name");
  if ($res) {
    if (SQL_num_rows($res)) {
      WinTStart();
      THItem(x("State"));
      THItem(x("Name"));
      THItem(x("Command"));
      while (($row=SQL_fetch_array($res))) {
        $c_stat=stat_getdetail("c$row[0]",""," and access>=from_unixtime(unix_timestamp()-25)");
	if ($c_stat[0][0])
	  $state=ShowImage(x("running"),PRG_PATH.'images/ic_gl.gif');
	elseif ($row[2])
	  $state=ShowImage(x("not running"),PRG_PATH.'images/ic_rb.gif');		
	else
	  $state=ShowImage(x("disabled"),PRG_PATH.'images/ic_rl.gif');	
      
        TLine("","colls.php?command=detail&id=$row[0]");
	TItem($state,'ALIGN="center"');
	TItem($row[1]);
	TItem(ShowLink(x("Detail"),"colls.php?command=detail&id=$row[0]"),'ALIGN="center"');
      }
      WinEnd();
    }
    else
      MsgInfo(x("No collectors found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();


function show_stat_val($stat,$name,$text,$period,$errval="-1",$cntavg="1") {
  if (!is_array($stat))
    return;
  for ($i=0;$i<count($stat);$i++) {
    if ($stat[$i][1]==$name) {
      TLine();
      TItem($text);
      if ($errval>=0) {
	if ($stat[$i][2] > $errval)
	  TItem(show_errorvalue($stat[$i][2]),'align="right"');
	else
          TItem(show_value($stat[$i][2]),'align="right"');
      }
      else
        TItem(show_value($stat[$i][2]),'align="right"');
      $valpsec=" ".round($stat[$i][2]/$period,1);
      if ($cntavg)
        TItem(show_value($valpsec,1),'align="right"');
      else
	TItem('-','align="right"');
    }
  }
}

function show_stat_time($stat,$name) {
  if (!is_array($stat))
    return;
  for ($i=0;$i<count($stat);$i++) {
    if ($stat[$i][1]==$name) {
      TLine();
      TItem(x("Start time:"));
      TItem(strftime("%Y-%m-%d %X",$stat[$i][2]),'align="right"');
      TLine();
      TItem(x("Uptime:"));
      TItem(get_uptime(time(NULL)-$stat[$i][2]),'align="right"');
    }
  }

}

?>