<?php
define('HELPMARK','status_database.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);


if ($subdelete)
  $command="delete";

check_command('kill','killsubmit','table','process','detail','delete','deletesubmit','sdetail','variable','flushs','flusht','forcet');

PageHead();
PageLogo();
MenuStart('status','MySubMenu');
switch ($command) {
  case "kill":
  case "killsubmit":
  case "process":
    PageTitle(x("Database processes"),'i_database.gif');
    break;  
  case "detail":
  case "table":
  case "delete":
  case "deletesubmit":
    PageTitle(x("Database tables"),'i_database.gif');
    break;
  case "variable":
    PageTitle(x("Database variables"),'i_database.gif');
    break;
  case "flushs":
  case "flusht":
  case "forcet":
    PageTitle(x("Database flush"),'i_database.gif');
    break;
  default:
    PageTitle(x("Database status"),'i_database.gif');
}

RequireRights("status");

demo_cmd("detail");
demo_cmd("table");
demo_cmd("delete");
demo_cmd("deletesubmit");
demo_cmd("variable");
demo_cmd("flushs");
demo_cmd("flusht");
demo_cmd("forcet");
demo_cmd("kill");
demo_cmd("killsubmit");
demo_cmd("process");


if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_table WRITE");

        if (!SQL_query("DROP TABLE IF EXISTS $v")) {
	  MsgError(x("Drop failed. Table %s wasn't removed."),$id);
	  $error=1;
	}
	else
	  SQL_query("DELETE FROM x_table WHERE id='$v'");
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected tables were deleted ...")); 
  }
  $command="table";
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected tables?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="table";
}


if ($command=="forcet") {
  if (SQL_query("FLUSH TABLES"))
    MsgInfo(x("All tables flushed."));
  else
    MsgError(x("Can't flush tables."));
}


if ($command=="flusht") {
  $query=0;
  $res=SQL_query("SHOW PROCESSLIST");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      if (eregi("QUERY",$row[4])&&(eregi("^CREATE.*",$row[7])||eregi("^INSERT.*",$row[7])||eregi("^UPDATE.*",$row[7])))
	$query=1;
    SQL_free_result($res);
  }
  if ($query)
    MsgInfo(x("Maybe long-run query is running...")." ".
	ShowLink(x("FORCE FLUSH TABLES"),"database.php?command=forcet"));
  elseif (SQL_query("FLUSH TABLES"))
    MsgInfo(x("All tables flushed."));
  else
    MsgError(x("Can't flush tables."));
}

if ($command=="flushs") {
  if (SQL_query("FLUSH STATUS"))
    MsgInfo(x("Status flushed."));
  else
    MsgError(x("Can't flush status."));
}


if ($command=="table") {
  $res=SQL_query("SHOW TABLES");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("Format"));
      THItem(x("Rows"));
      THItem(x("Average<BR>row length"));
      THItem(x("Data<BR>length"));
      THItem(x("Index<BR>length"));
      THItem(x("Total<BR>length"));
      THItem(x("Create<BR>time"));
      THItem(x("Update<BR>time"));
      THItem(x("Check<BR>time"));
      $i=0;
      while (($r=SQL_fetch_array($res))) {
        $used="";
        $pl=database_processlist();
	for ($j=0;($j<count($pl))&&!$used;$j++) {
	  
	  $table=stristr($pl[$j][7],"CREATE TABLE IF NOT EXISTS ");
	  $table=eregi_replace("CREATE TABLE IF NOT EXISTS ","",$table);
	  $table=eregi_replace("INSERT INTO ","",$table);
	  $table=eregi_replace(" .*","",$table);
	  if ($table==$r[0])
	    $used=$table;
	}
	if (!$used)
	  $row=database_detail($r[0]);
	else {
	  $row=array();
	  $row['Name']="<B>".$used."</B>";
	  $row['Row_format']="<B>".x("Used")."</B>";
	}
        TLine();
	TItem((!$used)?InputCheck("c__$i",$row[0]):"");
	TItem($row['Name']);
	TItem($row['Engine'].' '.$row['Row_format'],'ALIGN="right"');
	TItem($row['Rows'],'ALIGN="right"');
	TItem($row['Avg_row_length'],'ALIGN="right"');
	TItem(number2human($row['Data_length']),'ALIGN="right"');
	TItem(number2human($row['Index_length']),'ALIGN="right"');
	TItem(number2human($row['Data_length']+$row['Index_length']),'ALIGN="right"');
	TItem($row['Create_time'],'ALIGN="right"');
	TItem($row['Update_time'],'ALIGN="right"');
	TItem($row['Check_time'],'ALIGN="right"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="11" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No tables found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));  
}

if ($command=="kill") {
  FormStart();
  echo InputHidden("command","killsubmit");
  echo InputHidden("id",$id);  
  Dialog(MSGDLG_YESNO,"",x("Do you want to kill the process ID %d?",$id));
  FormEnd();
}


if ($command=="killsubmit") {
  if ($dlg_yes && is_numeric($id))
    SQL_query("KILL ".SQL_escape($id));
  $command="process";
}



if ($command=="process") {
  $res=SQL_query("SHOW PROCESSLIST");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      WinTStart();
      THItem(x("User"));
      THItem(x("Host"));
      THItem(x("DB"));
      THItem(x("State"));
      THItem(x("Time"));
      THItem(x("Info"));
      THItem(x("Command"));
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem($row[1]);
	TItem($row[2]);
	TItem($row[3]);
	TItem($row[4]." ".$row[6]);
	TItem($row[5]);
	TItem($row[7]);
	TItem(ShowLink(x("Kill thread"),"database.php?command=kill&id=$row[0]"),'ALIGN="center"');
      }
      WinEnd();
      FormEnd();
    }
    else
      MsgInfo(x("No processes found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}


if ($command=="variable") {
  $vars=database_variables();    
  if (is_array($vars) && count($vars)) {
    reset($vars);
    WinTStart();
    THItem(x("Variable"));
    THItem(x("Value"));
    while (list($name,$value) = each($vars)) {
      TLine();
      TItem($name);
      TItem($value);
    }
    WinEnd();
  }
  else
    MsgError(x("Database error")); 
}


if ($command=="sdetail") {
  $stats=database_status();    
  if (is_array($stats) && count($stats)) {
    MsgInfo(x("Database has been running for<BR>%s."),get_uptime($stats['Uptime']));
    
    reset($stats);
    WinTStart();
    THItem(x("Variable"));
    THItem(x("Value"));
    while (list($name,$value) = each($stats)) {
      TLine();
      TItem($name);
      TItem($value);
    }
    WinEnd();
  }
  else
    MsgError(x("Database error")); 
}

if ($command=="") {
  $stats=database_status();    
  if (is_array($stats) && count($stats)) {
    MsgInfo(x("Database has been running for<BR>%s."),get_uptime($stats['Uptime']));
    WinStart(x("Database traffic and connections"));
    THItem(x("Traffic"),'COLSPAN="2"');
    THItem(x("&oslash; per hour"));
    THItem("&nbsp;");
    THItem(x("Connections"),'COLSPAN="2"');
    THItem(x("&oslash; per hour"));
    TNext();
    TItem(x("Received:"));
    TItem(number2human($stats['Bytes_received'],"",2),'ALIGN="right"');
    TItem(number2human($stats['Bytes_received']/($stats['Uptime']/3600),"",2),'ALIGN="right"');
    TItem("&nbsp;");
    TItem(x("Failed attempts:"));
    TItem($stats['Aborted_connects'],'ALIGN="right"');
    TItem(number2human($stats['Aborted_connects']/($stats['Uptime']/3600),"",2),'ALIGN="right"');
    TNext();
    TItem(x("Sent:"));
    TItem(number2human($stats['Bytes_sent'],"",2),'ALIGN="right"');
    TItem(number2human($stats['Bytes_sent']/($stats['Uptime']/3600),"",2),'ALIGN="right"');
    TItem("&nbsp;");
    TItem(x("Aborted:"));
    TItem($stats['Aborted_clients'],'ALIGN="right"');
    TItem(number2human($stats['Aborted_clients']/($stats['Uptime']/3600),"",2),'ALIGN="right"');
    TNext();      
    TItem("<B>".x("Total:")."</B>");
    TItem("<B>".number2human($stats['Bytes_received']+$stats['Bytes_sent'])."</B>",'ALIGN="right"');
    TItem("<B>".number2human(($stats['Bytes_received']+$stats['Bytes_sent'])/($stats['Uptime']/3600),"",2)."</B>",'ALIGN="right"');
    TItem("&nbsp;");
    TItem("<B>".x("Total:")."</B>");
    TItem("<B>".($stats['Connections']+$stats['Aborted_clients']+$stats['Aborted_connects'])."</B>",'ALIGN="right"');
    TItem("<B>".number2human(($stats['Connections']+$stats['Aborted_clients']+$stats['Aborted_connects'])/($stats['Uptime']/3600),"",2)."</B>",'ALIGN="right"');
    WinEnd();    
      
    echo "<BR><BR>\n";
      
    WinStart(x("Database queries"));
    THItem(x("Total"));
    THItem(x("&oslash; per hour"));
    THItem(x("&oslash; per minute"));
    THItem(x("&oslash; per second"));
    TNext();
    TItem("<B>".($stats['Questions'])."</B>",'ALIGN="right"');
    TItem(number2human($stats['Questions']/($stats['Uptime']/3600),"",2),'ALIGN="right"');
    TItem(number2human($stats['Questions']/($stats['Uptime']/60),"",2),'ALIGN="right"');
    TItem(number2human($stats['Questions']/($stats['Uptime']),"",2),'ALIGN="right"');
    WinEnd();
  }
  else
    MsgError(x("Database error")); 
}

MenuEnd();
PageTail();


function MySubMenu() {
  global $command;
  $mysubmenu[]=array('caption'=>x("Status"),'url'=>'database.php?command=status');
  $mysubmenu[]=array('caption'=>x("Processes"),'url'=>'database.php?command=process');
  $mysubmenu[]=array('caption'=>x("Tables"),'url'=>'database.php?command=table');
  $mysubmenu[]=array('caption'=>x("Variables"),'url'=>'database.php?command=variable');
  $mysubmenu[]=array('caption'=>x("Flush status"),'url'=>'database.php?command=flushs');
  $mysubmenu[]=array('caption'=>x("Flush tables"),'url'=>'database.php?command=flusht');
  $mysubmenu[]=array('caption'=>x("Optimalization"),'url'=>'mysqlopt.php');
  MenuSub(x("Database"),$mysubmenu);
  
  $mysubmenu=array();
  if ($command=="" || $command=="status" || $command=="sdetail") {
    $mysubmenu[]=array('caption'=>x("Detail"),'url'=>'database.php?command=sdetail');   
    MenuSub(x("Status"),$mysubmenu);
  } 
}



function database_detail($name) {
  $ret=array();
  $res=SQL_query("SHOW TABLE STATUS LIKE '$name'");
  if ($res) {
    $ret=SQL_fetch_array($res);
    SQL_free_result($res);
  }
  return $ret;
}


function database_processlist() {
  $ret=array();
  $res=SQL_query("SHOW PROCESSLIST");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      $ret[]=$row;
    SQL_free_result($res);
  }
  return $ret;
}

function database_status() {
  $ret=array();
  $res=SQL_query("SHOW STATUS");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      $ret[$row[0]]=$row[1];
    SQL_free_result($res);
  }
  return $ret;
}

function database_variables() {
  $ret=array();
  $res=SQL_query("SHOW VARIABLES");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      $ret[$row[0]]=$row[1];
    SQL_free_result($res);
  }
  return $ret;
}


?>