<?php
define('HELPMARK','status_devices.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);

getGlobalVar('id',$id);

PageHead();
PageLogo();
MenuStart('status','MySubMenu');
PageTitle(x("Devices status"),'i_device.gif');
RequireRights("status");

check_command('detail');

if ($command=="detail") {
  if (!is_numeric($id))
    MsgFatal(x("Bad or unsupported ID"));

  $res=SQL_query("SELECT name,ip,snmp_enabled,snmp_community FROM x_device WHERE id='".SQL_escape($id)."'");
  if ($res) {
    if (($row=SQL_fetch_array($res))) {
      $name=$row[0];
      $ip=$row[1];
      $snmp_enabled=$row[2];
      $snmp_community=$row[3];
    }
    SQL_free_result($res);
  }


  if (is_ip($ip) && $snmp_enabled) {
    $sysDescr = my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.1");
    if (is_array($sysDescr)) {
      $sysUptime 	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.3");
      $sysContact 	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.4");
      $sysName 		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.5");
      $sysLocation 	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.6");
      $sysServices 	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.1.7");
      $ifIndex		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.1");
      $ifDescr		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.2");
      $ifType		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.3");
      $ifMtu		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.4");
      $ifSpeed		= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.5");
      $ifPhyAddr	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.6");
      $ifAdminStatus	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.7");
      $ifOperStatus	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.8");
      $ifInOctect	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.10");
      $ifInDiscard	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.13");
      $ifInError	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.14");
      $ifOutOctect	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.16");
      $ifOutDiscard	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.19");
      $ifOutError	= @my_snmpwalk($ip,$snmp_community,".1.3.6.1.2.1.2.2.1.20");
	
      WinStart(x("System information"));
      TItem(x("System name:"));
      TItem($sysName);
      TLine();
      TItem(x("Description:"));
      TItem($sysDescr);
      TLine();
      TItem(x("Location:"));
      TItem($sysLocation);
      TLine();
      TItem(x("Contact:"));
      TItem(formatlinkstring($sysContact[0]));
      TLine();
      TItem(x("Uptime:"));
      TItem($sysUptime);
      TLine();
      TItem(x("Services:"));
      TItem($sysServices);
      WinEnd();
	  
      echo "<BR><BR>\n";
	  
      WinTStart();
      THItem(x("ifIndex"));
      THItem(x("Description"));
      THItem(x("Type"));
      THItem(x("MTU"));
      THItem(x("Speed"));
      THItem(x("Physical address"));
      THItem(x("Admin status"));
      THItem(x("Operation status"));
      THItem(x("Input octets"));
      THItem(x("Input discards"));
      THItem(x("Input errors"));
      THItem(x("Output octets"));
      THItem(x("Output discards"));      
      THItem(x("Output errors"));
      for ($i=0;$i<count($ifIndex);$i++) {
	TLine();
	TItem($ifIndex[$i],"ALIGN=\"right\"");
	TItem($ifDescr[$i]);
	TItem($ifType[$i]);
	TItem($ifMtu[$i]);
	TItem(number2human($ifSpeed[$i],"",0),"ALIGN=\"right\"");
	TItem('<CODE>'.format_mac_address($ifPhyAddr[$i]).'</CODE>','TITLE="'.get_mac_info($ifPhyAddr[$i]).'" NOWRAP');
	TItem(interface_updown($ifAdminStatus[$i]));
	TItem(interface_updown($ifOperStatus[$i]));
	TItem(number2human($ifInOctect[$i],"",0),"ALIGN=\"right\"");
	TItem(interface_error(number2human($ifInDiscard[$i],"",0)),"ALIGN=\"right\"");
	TItem(interface_error(number2human($ifInError[$i],"",0)),"ALIGN=\"right\"");
	TItem(number2human($ifOutOctect[$i]),"ALIGN=\"right\"");
	TItem(interface_error(number2human($ifOutDiscard[$i],"",0)),"ALIGN=\"right\"");
	TItem(interface_error(number2human($ifOutError[$i],"",0)),"ALIGN=\"right\"");
      }
      WinEnd();
    }
    else
      MsgError(x("Check router IP address and/or snmp community"),x("Connect Error"));
  }
  else
    MsgInfo("SNMP disabled or router IP isn't configured correctly.");
}


if ($command=="") {
  $res=SQL_query("SELECT id,name,ip,snmp_enabled,comment FROM x_device ORDER BY name");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      WinTStart();
      THItem(x("Name"));
      THItem(x("Comment"));      
      THItem(x("Command"));
      while (($row=SQL_fetch_array($res))) {
        TLine("",($row[2]&&$row[3])?"devices.php?command=detail&id=$row[0]":"");
	TItem($row[1]);
	TItem(str_strip($row[4]));
	TItem(($row[2]&&$row[3])?ShowLink(x("Detail"),"devices.php?command=detail&id=$row[0]"):"",'ALIGN="center"');
      }
      WinEnd();
      FormEnd();
    }
    else
      MsgInfo(x("No devices found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();


function interface_updown($text) {
  if (strstr($text,"up")!=FALSE)
    return "<FONT COLOR=\"green\">$text</FONT>";
  if (strstr($text,"down")!=FALSE)
    return "<FONT COLOR=\"red\">$text</FONT>";
  return $text;  
}
  
function interface_error($text) {
  if ($text>0)
    return "<FONT COLOR=\"red\">$text</FONT>";
  return $text;
}


function format_mac_address($mac) {
  $p=split('[:.-]',$mac);
  if (count($p)==6) {
    while (list($key,$val) = each($p)) 
      if (strlen($val)==1)
	$p[$key]="0".$val;
    $prefix="$p[0]-$p[1]-$p[2]-$p[3]-$p[4]-$p[5]";
  }
  elseif (count($p) == 3)
    $prefix=sprintf("%02x-%02x-%02x-%02x-%02x-%02x",
		    floor(hexdec($p[0])/256),floor(hexdec($p[0])%256),
		    floor(hexdec($p[1])/256),floor(hexdec($p[1])%256),
		    floor(hexdec($p[2])/256),floor(hexdec($p[2])%256));
  else
    $prefix=$mac;
  return strtoupper($prefix);
}


function get_mac_info($mac) {
  $ret="";
  $prefix="";
  $p=split('-',format_mac_address($mac));
  if (count($p)==6)
    $prefix="$p[0]-$p[1]-$p[2]";

  if ($prefix) {
    $ret=x("unknow vendor");
    $res=SQL_query("SELECT name from x_mac WHERE prefix='$prefix' LIMIT 1");
    if ($res) {
      $row=SQL_fetch_array($res);
      $ret=$row[0];
      SQL_free_result($res);
    }
  }
  return $ret;
}


function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>"devices.php");
  MenuSub(x("Devices"),$mysubmenu);
}


?>